"use strict";
(self["webpackChunkjupyterlab_collaborative_chat_extension"] = self["webpackChunkjupyterlab_collaborative_chat_extension"] || []).push([["packages_jupyter-chat_lib_index_js"],{

/***/ "../../packages/jupyter-chat/lib/active-cell-manager.js":
/*!**************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/active-cell-manager.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ActiveCellManager: () => (/* binding */ ActiveCellManager)
/* harmony export */ });
/* harmony import */ var _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/application */ "webpack/sharing/consume/default/@jupyterlab/application");
/* harmony import */ var _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_2__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */



/**
 * A manager that maintains a reference to the current active notebook cell in
 * the main panel (if any), and provides methods for inserting or appending
 * content to the active cell.
 *
 * The current active cell should be obtained by listening to the
 * `activeCellChanged` signal.
 */
class ActiveCellManager {
    constructor(options) {
        var _a, _b;
        this._onMainAreaChanged = () => {
            var _a, _b;
            const value = (_b = (_a = this._notebookTracker.currentWidget) === null || _a === void 0 ? void 0 : _a.isVisible) !== null && _b !== void 0 ? _b : false;
            if (value !== this._notebookVisible) {
                this._notebookVisible = value;
                this._available = !!this._activeCell && this._notebookVisible;
                this._availabilityChanged.emit(this._available);
            }
        };
        /**
         * Handle the change of active notebook cell.
         */
        this._onActiveCellChanged = (_, activeCell) => {
            var _a;
            if (this._activeCell !== activeCell) {
                (_a = this._activeCell) === null || _a === void 0 ? void 0 : _a.model.stateChanged.disconnect(this._cellStateChange);
                this._activeCell = activeCell;
                activeCell === null || activeCell === void 0 ? void 0 : activeCell.ready.then(() => {
                    var _a, _b;
                    (_a = this._activeCell) === null || _a === void 0 ? void 0 : _a.model.stateChanged.connect(this._cellStateChange);
                    this._available = !!this._activeCell && this._notebookVisible;
                    this._availabilityChanged.emit(this._available);
                    (_b = this._activeCell) === null || _b === void 0 ? void 0 : _b.disposed.connect(() => {
                        this._activeCell = null;
                    });
                });
            }
        };
        /**
         * Handle the change of the active cell state.
         */
        this._cellStateChange = (_, change) => {
            var _a;
            if (change.name === 'executionCount') {
                const currSharedModel = (_a = this._activeCell) === null || _a === void 0 ? void 0 : _a.model.sharedModel;
                const prevActiveCellError = this._activeCellError;
                let currActiveCellError = null;
                if (currSharedModel && 'outputs' in currSharedModel) {
                    currActiveCellError =
                        currSharedModel.outputs.find((output) => output.output_type === 'error') || null;
                }
                // for some reason, the `CellError` object is not referentially stable,
                // meaning that this condition always evaluates to `true` and the
                // `activeCellErrorChanged` signal is emitted every 200ms, even when the
                // error output is unchanged. this is why we have to rely on
                // `execution_count` to track changes to the error output.
                if (prevActiveCellError !== currActiveCellError) {
                    this._activeCellError = currActiveCellError;
                    this._activeCellErrorChanged.emit(this._activeCellError);
                }
            }
        };
        /**
         * Whether the current notebook panel is visible or not.
         */
        this._notebookVisible = false;
        /**
         * The active cell.
         */
        this._activeCell = null;
        this._available = false;
        this._activeCellError = null;
        this._availabilityChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this);
        this._activeCellErrorChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this);
        this._notebookTracker = options.tracker;
        this._notebookTracker.activeCellChanged.connect(this._onActiveCellChanged);
        (_a = options.shell.currentChanged) === null || _a === void 0 ? void 0 : _a.connect(this._onMainAreaChanged);
        if (options.shell instanceof _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__.LabShell) {
            (_b = options.shell.layoutModified) === null || _b === void 0 ? void 0 : _b.connect(this._onMainAreaChanged);
        }
        this._onMainAreaChanged();
    }
    /**
     * Whether the notebook is available and an active cell exists.
     */
    get available() {
        return this._available;
    }
    /**
     * The `CellError` output within the active cell, if any.
     */
    get activeCellError() {
        return this._activeCellError;
    }
    /**
     * A signal emitting when the active cell changed.
     */
    get availabilityChanged() {
        return this._availabilityChanged;
    }
    /**
     * A signal emitting when the error state of the active cell changed.
     */
    get activeCellErrorChanged() {
        return this._activeCellErrorChanged;
    }
    getContent(withError = false) {
        var _a;
        const sharedModel = (_a = this._notebookTracker.activeCell) === null || _a === void 0 ? void 0 : _a.model.sharedModel;
        if (!sharedModel) {
            return null;
        }
        // case where withError = false
        if (!withError) {
            return {
                type: sharedModel.cell_type,
                source: sharedModel.getSource()
            };
        }
        // case where withError = true
        const error = this._activeCellError;
        if (error) {
            return {
                type: 'code',
                source: sharedModel.getSource(),
                error: {
                    name: error.ename,
                    value: error.evalue,
                    traceback: error.traceback
                }
            };
        }
        return null;
    }
    /**
     * Inserts `content` in a new cell above the active cell.
     */
    insertAbove(content) {
        const notebookPanel = this._notebookTracker.currentWidget;
        if (!notebookPanel || !notebookPanel.isVisible) {
            return;
        }
        // create a new cell above the active cell and mark new cell as active
        _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.insertAbove(notebookPanel.content);
        // replace content of this new active cell
        this.replace(content);
    }
    /**
     * Inserts `content` in a new cell below the active cell.
     */
    insertBelow(content) {
        const notebookPanel = this._notebookTracker.currentWidget;
        if (!notebookPanel || !notebookPanel.isVisible) {
            return;
        }
        // create a new cell below the active cell and mark new cell as active
        _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.insertBelow(notebookPanel.content);
        // replace content of this new active cell
        this.replace(content);
    }
    /**
     * Replaces the contents of the active cell.
     */
    async replace(content) {
        var _a;
        const notebookPanel = this._notebookTracker.currentWidget;
        if (!notebookPanel || !notebookPanel.isVisible) {
            return;
        }
        // get reference to active cell directly from Notebook API. this avoids the
        // possibility of acting on an out-of-date reference.
        const activeCell = this._notebookTracker.activeCell;
        if (!activeCell) {
            return;
        }
        // wait for editor to be ready
        await activeCell.ready;
        // replace the content of the active cell
        /**
         * NOTE: calling this method sometimes emits an error to the browser console:
         *
         * ```
         * Error: Calls to EditorView.update are not allowed while an update is in progress
         * ```
         *
         * However, there seems to be no impact on the behavior/stability of the
         * JupyterLab application after this error is logged. Furthermore, this is
         * the official API for setting the content of a cell in JupyterLab 4,
         * meaning that this is likely unavoidable.
         */
        (_a = activeCell.editor) === null || _a === void 0 ? void 0 : _a.model.sharedModel.setSource(content);
    }
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/chat-input.js":
/*!****************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/chat-input.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChatInput: () => (/* binding */ ChatInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Autocomplete/Autocomplete.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/TextField/TextField.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/InputAdornment/InputAdornment.js");
/* harmony import */ var clsx__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! clsx */ "../../node_modules/clsx/dist/clsx.mjs");
/* harmony import */ var _input_cancel_button__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./input/cancel-button */ "../../packages/jupyter-chat/lib/components/input/cancel-button.js");
/* harmony import */ var _input_send_button__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./input/send-button */ "../../packages/jupyter-chat/lib/components/input/send-button.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */





const INPUT_BOX_CLASS = 'jp-chat-input-container';
function ChatInput(props) {
    var _a, _b, _c, _d;
    const { autocompletionName, autocompletionRegistry, model } = props;
    const autocompletion = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)();
    const [input, setInput] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(props.value || '');
    const [sendWithShiftEnter, setSendWithShiftEnter] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)((_a = model.config.sendWithShiftEnter) !== null && _a !== void 0 ? _a : false);
    const [typingNotification, setTypingNotification] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)((_b = model.config.sendTypingNotification) !== null && _b !== void 0 ? _b : false);
    // Display the include selection menu if it is not explicitly hidden, and if at least
    // one of the tool to check for text or cell selection is enabled.
    let hideIncludeSelection = (_c = props.hideIncludeSelection) !== null && _c !== void 0 ? _c : false;
    if (model.activeCellManager === null && model.selectionWatcher === null) {
        hideIncludeSelection = true;
    }
    // store reference to the input element to enable focusing it easily
    const inputRef = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)();
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        var _a;
        const configChanged = (_, config) => {
            var _a, _b;
            setSendWithShiftEnter((_a = config.sendWithShiftEnter) !== null && _a !== void 0 ? _a : false);
            setTypingNotification((_b = config.sendTypingNotification) !== null && _b !== void 0 ? _b : false);
        };
        model.configChanged.connect(configChanged);
        const focusInputElement = () => {
            if (inputRef.current) {
                inputRef.current.focus();
            }
        };
        (_a = model.focusInputSignal) === null || _a === void 0 ? void 0 : _a.connect(focusInputElement);
        return () => {
            var _a, _b;
            (_a = model.configChanged) === null || _a === void 0 ? void 0 : _a.disconnect(configChanged);
            (_b = model.focusInputSignal) === null || _b === void 0 ? void 0 : _b.disconnect(focusInputElement);
        };
    }, [model]);
    // The autocomplete commands options.
    const [commandOptions, setCommandOptions] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
    // whether any option is highlighted in the slash command autocomplete
    const [highlighted, setHighlighted] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    // controls whether the slash command autocomplete is open
    const [open, setOpen] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    /**
     * Effect: fetch the list of available autocomplete commands.
     */
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if (autocompletionRegistry === undefined) {
            return;
        }
        autocompletion.current = autocompletionName
            ? autocompletionRegistry.get(autocompletionName)
            : autocompletionRegistry.getDefaultCompletion();
        if (autocompletion.current === undefined) {
            return;
        }
        if (Array.isArray(autocompletion.current.commands)) {
            setCommandOptions(autocompletion.current.commands);
        }
        else if (typeof autocompletion.current.commands === 'function') {
            autocompletion.current
                .commands()
                .then((commands) => {
                setCommandOptions(commands);
            });
        }
    }, []);
    /**
     * Effect: Open the autocomplete when the user types the 'opener' string into an
     * empty chat input. Close the autocomplete and reset the last selected value when
     * the user clears the chat input.
     */
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        var _a, _b;
        if (!((_a = autocompletion.current) === null || _a === void 0 ? void 0 : _a.opener)) {
            return;
        }
        if (input === ((_b = autocompletion.current) === null || _b === void 0 ? void 0 : _b.opener)) {
            setOpen(true);
            return;
        }
        if (input === '') {
            setOpen(false);
            return;
        }
    }, [input]);
    function handleKeyDown(event) {
        if (event.key !== 'Enter') {
            return;
        }
        // do not send the message if the user was selecting a suggested command from the
        // Autocomplete component.
        if (highlighted) {
            return;
        }
        if (event.key === 'Enter' &&
            ((sendWithShiftEnter && event.shiftKey) ||
                (!sendWithShiftEnter && !event.shiftKey))) {
            onSend();
            event.stopPropagation();
            event.preventDefault();
        }
    }
    /**
     * Triggered when sending the message.
     *
     * Add code block if cell or text is selected.
     */
    function onSend(selection) {
        let content = input;
        if (selection) {
            content += `

\`\`\`
${selection.source}
\`\`\`
`;
        }
        props.onSend(content);
        setInput('');
    }
    /**
     * Triggered when cancelling edition.
     */
    function onCancel() {
        setInput(props.value || '');
        props.onCancel();
    }
    // Set the helper text based on whether Shift+Enter is used for sending.
    const helperText = sendWithShiftEnter ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", null,
        "Press ",
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("b", null, "Shift"),
        "+",
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("b", null, "Enter"),
        " to send message")) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", null,
        "Press ",
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("b", null, "Shift"),
        "+",
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("b", null, "Enter"),
        " to add a new line"));
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { sx: props.sx, className: (0,clsx__WEBPACK_IMPORTED_MODULE_1__["default"])(INPUT_BOX_CLASS) },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { options: commandOptions, value: props.value, open: open, autoHighlight: true, freeSolo: true, 
            // ensure the autocomplete popup always renders on top
            componentsProps: {
                popper: {
                    placement: 'top'
                },
                paper: {
                    sx: {
                        border: '1px solid lightgray'
                    }
                }
            }, ListboxProps: {
                sx: {
                    '& .MuiAutocomplete-option': {
                        padding: 2
                    }
                }
            }, renderInput: params => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { ...params, fullWidth: true, variant: "outlined", multiline: true, onKeyDown: handleKeyDown, placeholder: "Start chatting", inputRef: inputRef, InputProps: {
                    ...params.InputProps,
                    endAdornment: (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { position: "end" },
                        props.onCancel && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_input_cancel_button__WEBPACK_IMPORTED_MODULE_6__.CancelButton, { inputExists: input.length > 0, onCancel: onCancel })),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_input_send_button__WEBPACK_IMPORTED_MODULE_7__.SendButton, { model: model, sendWithShiftEnter: sendWithShiftEnter, inputExists: input.length > 0, onSend: onSend, hideIncludeSelection: hideIncludeSelection, hasButtonOnLeft: !!props.onCancel })))
                }, FormHelperTextProps: {
                    sx: { marginLeft: 'auto', marginRight: 0 }
                }, helperText: input.length > 2 ? helperText : ' ' })), ...(_d = autocompletion.current) === null || _d === void 0 ? void 0 : _d.props, inputValue: input, onInputChange: (_, newValue) => {
                setInput(newValue);
                if (typingNotification && model.inputChanged) {
                    model.inputChanged(newValue);
                }
            }, onHighlightChange: 
            /**
             * On highlight change: set `highlighted` to whether an option is
             * highlighted by the user.
             *
             * This isn't called when an option is selected for some reason, so we
             * need to call `setHighlighted(false)` in `onClose()`.
             */
            (_, highlightedOption) => {
                setHighlighted(!!highlightedOption);
            }, onClose: 
            /**
             * On close: set `highlighted` to `false` and close the popup by
             * setting `open` to `false`.
             */
            () => {
                setHighlighted(false);
                setOpen(false);
            }, 
            // hide default extra right padding in the text field
            disableClearable: true })));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/chat-messages.js":
/*!*******************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/chat-messages.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Avatar: () => (/* binding */ Avatar),
/* harmony export */   ChatMessage: () => (/* binding */ ChatMessage),
/* harmony export */   ChatMessageHeader: () => (/* binding */ ChatMessageHeader),
/* harmony export */   ChatMessages: () => (/* binding */ ChatMessages),
/* harmony export */   Navigation: () => (/* binding */ Navigation),
/* harmony export */   Writers: () => (/* binding */ Writers)
/* harmony export */ });
/* harmony import */ var _jupyter_react_components__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter/react-components */ "webpack/sharing/consume/default/@jupyter/react-components");
/* harmony import */ var _jupyter_react_components__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_react_components__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Avatar/Avatar.js");
/* harmony import */ var clsx__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! clsx */ "../../node_modules/clsx/dist/clsx.mjs");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _chat_input__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./chat-input */ "../../packages/jupyter-chat/lib/components/chat-input.js");
/* harmony import */ var _rendermime_markdown__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./rendermime-markdown */ "../../packages/jupyter-chat/lib/components/rendermime-markdown.js");
/* harmony import */ var _scroll_container__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./scroll-container */ "../../packages/jupyter-chat/lib/components/scroll-container.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */








const MESSAGES_BOX_CLASS = 'jp-chat-messages-container';
const MESSAGE_CLASS = 'jp-chat-message';
const MESSAGE_STACKED_CLASS = 'jp-chat-message-stacked';
const MESSAGE_HEADER_CLASS = 'jp-chat-message-header';
const MESSAGE_TIME_CLASS = 'jp-chat-message-time';
const WRITERS_CLASS = 'jp-chat-writers';
const NAVIGATION_BUTTON_CLASS = 'jp-chat-navigation';
const NAVIGATION_UNREAD_CLASS = 'jp-chat-navigation-unread';
const NAVIGATION_TOP_CLASS = 'jp-chat-navigation-top';
const NAVIGATION_BOTTOM_CLASS = 'jp-chat-navigation-bottom';
/**
 * The messages list component.
 */
function ChatMessages(props) {
    const { model } = props;
    const [messages, setMessages] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(model.messages);
    const refMsgBox = (0,react__WEBPACK_IMPORTED_MODULE_3__.useRef)(null);
    const inViewport = (0,react__WEBPACK_IMPORTED_MODULE_3__.useRef)([]);
    const [currentWriters, setCurrentWriters] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)([]);
    // The intersection observer that listen to all the message visibility.
    const observerRef = (0,react__WEBPACK_IMPORTED_MODULE_3__.useRef)(new IntersectionObserver(viewportChange));
    /**
     * Effect: fetch history and config on initial render
     */
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        async function fetchHistory() {
            if (!model.getHistory) {
                return;
            }
            model
                .getHistory()
                .then(history => setMessages(history.messages))
                .catch(e => console.error(e));
        }
        fetchHistory();
        setCurrentWriters([]);
    }, [model]);
    /**
     * Effect: listen to chat messages.
     */
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        var _a;
        function handleChatEvents() {
            setMessages([...model.messages]);
        }
        function handleWritersChange(_, writers) {
            setCurrentWriters(writers);
        }
        model.messagesUpdated.connect(handleChatEvents);
        (_a = model.writersChanged) === null || _a === void 0 ? void 0 : _a.connect(handleWritersChange);
        return function cleanup() {
            var _a;
            model.messagesUpdated.disconnect(handleChatEvents);
            (_a = model.writersChanged) === null || _a === void 0 ? void 0 : _a.disconnect(handleChatEvents);
        };
    }, [model]);
    /**
     * Function called when a message enter or leave the viewport.
     */
    function viewportChange(entries) {
        const unread = [...model.unreadMessages];
        let unreadModified = false;
        entries.forEach(entry => {
            var _a;
            const index = parseInt((_a = entry.target.getAttribute('data-index')) !== null && _a !== void 0 ? _a : '');
            if (!isNaN(index)) {
                if (unread.length) {
                    const unreadIdx = unread.indexOf(index);
                    if (unreadIdx !== -1 && entry.isIntersecting) {
                        unread.splice(unreadIdx, 1);
                        unreadModified = true;
                    }
                }
                const viewportIdx = inViewport.current.indexOf(index);
                if (!entry.isIntersecting && viewportIdx !== -1) {
                    inViewport.current.splice(viewportIdx, 1);
                }
                else if (entry.isIntersecting && viewportIdx === -1) {
                    inViewport.current.push(index);
                }
            }
        });
        props.model.messagesInViewport = inViewport.current;
        if (unreadModified) {
            props.model.unreadMessages = unread;
        }
        return () => {
            var _a;
            (_a = observerRef.current) === null || _a === void 0 ? void 0 : _a.disconnect();
        };
    }
    return (react__WEBPACK_IMPORTED_MODULE_3___default().createElement((react__WEBPACK_IMPORTED_MODULE_3___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_scroll_container__WEBPACK_IMPORTED_MODULE_4__.ScrollContainer, { sx: { flexGrow: 1 } },
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { ref: refMsgBox, className: (0,clsx__WEBPACK_IMPORTED_MODULE_2__["default"])(MESSAGES_BOX_CLASS) }, messages.map((message, i) => {
                return (
                // extra div needed to ensure each bubble is on a new line
                react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { key: i, className: (0,clsx__WEBPACK_IMPORTED_MODULE_2__["default"])(MESSAGE_CLASS, message.stacked ? MESSAGE_STACKED_CLASS : '') },
                    react__WEBPACK_IMPORTED_MODULE_3___default().createElement(ChatMessageHeader, { message: message }),
                    react__WEBPACK_IMPORTED_MODULE_3___default().createElement(ChatMessage, { ...props, message: message, observer: observerRef.current, index: i })));
            })),
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(Writers, { writers: currentWriters })),
        react__WEBPACK_IMPORTED_MODULE_3___default().createElement(Navigation, { ...props, refMsgBox: refMsgBox })));
}
/**
 * The message header component.
 */
function ChatMessageHeader(props) {
    var _a, _b;
    const [datetime, setDatetime] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)({});
    const message = props.message;
    const sender = message.sender;
    /**
     * Effect: update cached datetime strings upon receiving a new message.
     */
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        if (!datetime[message.time]) {
            const newDatetime = {};
            let datetime;
            const currentDate = new Date();
            const sameDay = (date) => date.getFullYear() === currentDate.getFullYear() &&
                date.getMonth() === currentDate.getMonth() &&
                date.getDate() === currentDate.getDate();
            const msgDate = new Date(message.time * 1000); // Convert message time to milliseconds
            // Display only the time if the day of the message is the current one.
            if (sameDay(msgDate)) {
                // Use the browser's default locale
                datetime = msgDate.toLocaleTimeString([], {
                    hour: 'numeric',
                    minute: '2-digit'
                });
            }
            else {
                // Use the browser's default locale
                datetime = msgDate.toLocaleString([], {
                    day: 'numeric',
                    month: 'numeric',
                    year: 'numeric',
                    hour: 'numeric',
                    minute: '2-digit'
                });
            }
            newDatetime[message.time] = datetime;
            setDatetime(newDatetime);
        }
    });
    const avatar = message.stacked ? null : Avatar({ user: sender });
    const name = (_b = (_a = sender.display_name) !== null && _a !== void 0 ? _a : sender.name) !== null && _b !== void 0 ? _b : (sender.username || 'User undefined');
    return (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { className: MESSAGE_HEADER_CLASS, sx: {
            display: 'flex',
            alignItems: 'center',
            '& > :not(:last-child)': {
                marginRight: 3
            },
            marginBottom: message.stacked ? '0px' : '12px',
            ...props.sx
        } },
        avatar,
        react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { sx: {
                display: 'flex',
                flexGrow: 1,
                flexWrap: 'wrap',
                justifyContent: 'space-between',
                alignItems: 'center'
            } },
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { sx: { display: 'flex', alignItems: 'center' } },
                !message.stacked && (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { sx: {
                        fontWeight: 700,
                        color: 'var(--jp-ui-font-color1)',
                        paddingRight: '0.5em'
                    } }, name)),
                (message.deleted || message.edited) && (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { sx: {
                        fontStyle: 'italic',
                        fontSize: 'var(--jp-content-font-size0)'
                    } }, message.deleted ? '(message deleted)' : '(edited)'))),
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { className: MESSAGE_TIME_CLASS, sx: {
                    fontSize: '0.8em',
                    color: 'var(--jp-ui-font-color2)',
                    fontWeight: 300
                }, title: message.raw_time ? 'Unverified time' : '' }, `${datetime[message.time]}${message.raw_time ? '*' : ''}`))));
}
/**
 * The message component body.
 */
function ChatMessage(props) {
    const { message, model, rmRegistry } = props;
    const elementRef = (0,react__WEBPACK_IMPORTED_MODULE_3__.useRef)(null);
    const [edit, setEdit] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(false);
    const [deleted, setDeleted] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(false);
    const [canEdit, setCanEdit] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(false);
    const [canDelete, setCanDelete] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(false);
    // Add the current message to the observer, to actualize viewport and unread messages.
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        var _a;
        if (elementRef.current === null) {
            return;
        }
        // If the observer is defined, let's observe the message.
        (_a = props.observer) === null || _a === void 0 ? void 0 : _a.observe(elementRef.current);
        return () => {
            var _a;
            if (elementRef.current !== null) {
                (_a = props.observer) === null || _a === void 0 ? void 0 : _a.unobserve(elementRef.current);
            }
        };
    }, [model]);
    // Look if the message can be deleted or edited.
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        var _a;
        setDeleted((_a = message.deleted) !== null && _a !== void 0 ? _a : false);
        if (model.user !== undefined && !message.deleted) {
            if (model.user.username === message.sender.username) {
                setCanEdit(model.updateMessage !== undefined);
                setCanDelete(model.deleteMessage !== undefined);
            }
        }
        else {
            setCanEdit(false);
            setCanDelete(false);
        }
    }, [model, message]);
    // Cancel the current edition of the message.
    const cancelEdition = () => {
        setEdit(false);
    };
    // Update the content of the message.
    const updateMessage = (id, input) => {
        if (!canEdit) {
            return;
        }
        // Update the message
        const updatedMessage = { ...message };
        updatedMessage.body = input;
        model.updateMessage(id, updatedMessage);
        setEdit(false);
    };
    // Delete the message.
    const deleteMessage = (id) => {
        if (!canDelete) {
            return;
        }
        model.deleteMessage(id);
    };
    // Empty if the message has been deleted.
    return deleted ? (react__WEBPACK_IMPORTED_MODULE_3___default().createElement("div", { ref: elementRef, "data-index": props.index })) : (react__WEBPACK_IMPORTED_MODULE_3___default().createElement("div", { ref: elementRef, "data-index": props.index }, edit && canEdit ? (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_chat_input__WEBPACK_IMPORTED_MODULE_7__.ChatInput, { value: message.body, onSend: (input) => updateMessage(message.id, input), onCancel: () => cancelEdition(), model: model, hideIncludeSelection: true })) : (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_rendermime_markdown__WEBPACK_IMPORTED_MODULE_8__.RendermimeMarkdown, { rmRegistry: rmRegistry, markdownStr: message.body, model: model, edit: canEdit ? () => setEdit(true) : undefined, delete: canDelete ? () => deleteMessage(message.id) : undefined }))));
}
/**
 * The writers component, displaying the current writers.
 */
function Writers(props) {
    const { writers } = props;
    return writers.length > 0 ? (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { className: WRITERS_CLASS },
        writers.map((writer, index) => {
            var _a, _b;
            return (react__WEBPACK_IMPORTED_MODULE_3___default().createElement("div", null,
                react__WEBPACK_IMPORTED_MODULE_3___default().createElement(Avatar, { user: writer, small: true }),
                react__WEBPACK_IMPORTED_MODULE_3___default().createElement("span", null, (_b = (_a = writer.display_name) !== null && _a !== void 0 ? _a : writer.name) !== null && _b !== void 0 ? _b : (writer.username || 'User undefined')),
                react__WEBPACK_IMPORTED_MODULE_3___default().createElement("span", null, index < writers.length - 1
                    ? index < writers.length - 2
                        ? ', '
                        : ' and '
                    : '')));
        }),
        react__WEBPACK_IMPORTED_MODULE_3___default().createElement("span", null, (writers.length > 1 ? ' are' : ' is') + ' writing'))) : null;
}
/**
 * The navigation component, to navigate to unread messages.
 */
function Navigation(props) {
    const { model } = props;
    const [lastInViewport, setLastInViewport] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(true);
    const [unreadBefore, setUnreadBefore] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(null);
    const [unreadAfter, setUnreadAfter] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(null);
    const gotoMessage = (msgIdx) => {
        var _a, _b;
        (_b = (_a = props.refMsgBox.current) === null || _a === void 0 ? void 0 : _a.children.item(msgIdx)) === null || _b === void 0 ? void 0 : _b.scrollIntoView();
    };
    // Listen for change in unread messages, and find the first unread message before or
    // after the current viewport, to display navigation buttons.
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        var _a;
        const unreadChanged = (model, unreadIndexes) => {
            const viewport = model.messagesInViewport;
            if (!viewport) {
                return;
            }
            // Initialize the next values with the current values if there still relevant.
            let before = unreadBefore !== null &&
                unreadIndexes.includes(unreadBefore) &&
                unreadBefore < Math.min(...viewport)
                ? unreadBefore
                : null;
            let after = unreadAfter !== null &&
                unreadIndexes.includes(unreadAfter) &&
                unreadAfter > Math.max(...viewport)
                ? unreadAfter
                : null;
            unreadIndexes.forEach(unread => {
                if (viewport === null || viewport === void 0 ? void 0 : viewport.includes(unread)) {
                    return;
                }
                if (unread < (before !== null && before !== void 0 ? before : Math.min(...viewport))) {
                    before = unread;
                }
                else if (unread > Math.max(...viewport) &&
                    unread < (after !== null && after !== void 0 ? after : model.messages.length)) {
                    after = unread;
                }
            });
            setUnreadBefore(before);
            setUnreadAfter(after);
        };
        (_a = model.unreadChanged) === null || _a === void 0 ? void 0 : _a.connect(unreadChanged);
        unreadChanged(model, model.unreadMessages);
        // Move to first the unread message or to last message on first rendering.
        if (model.unreadMessages.length) {
            gotoMessage(Math.min(...model.unreadMessages));
        }
        else {
            gotoMessage(model.messages.length - 1);
        }
        return () => {
            var _a;
            (_a = model.unreadChanged) === null || _a === void 0 ? void 0 : _a.disconnect(unreadChanged);
        };
    }, [model]);
    // Listen for change in the viewport, to add a navigation button if the last is not
    // in viewport.
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        var _a, _b;
        const viewportChanged = (model, viewport) => {
            setLastInViewport(viewport.includes(model.messages.length - 1));
        };
        (_a = model.viewportChanged) === null || _a === void 0 ? void 0 : _a.connect(viewportChanged);
        viewportChanged(model, (_b = model.messagesInViewport) !== null && _b !== void 0 ? _b : []);
        return () => {
            var _a;
            (_a = model.viewportChanged) === null || _a === void 0 ? void 0 : _a.disconnect(viewportChanged);
        };
    }, [model]);
    return (react__WEBPACK_IMPORTED_MODULE_3___default().createElement((react__WEBPACK_IMPORTED_MODULE_3___default().Fragment), null,
        unreadBefore !== null && (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_jupyter_react_components__WEBPACK_IMPORTED_MODULE_0__.Button, { className: `${NAVIGATION_BUTTON_CLASS} ${NAVIGATION_UNREAD_CLASS} ${NAVIGATION_TOP_CLASS}`, onClick: () => gotoMessage(unreadBefore), title: 'Go to unread messages' },
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.LabIcon.resolveReact, { display: 'flex', icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.caretDownEmptyIcon, iconClass: (0,_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.classes)('jp-Icon') }))),
        (unreadAfter !== null || !lastInViewport) && (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_jupyter_react_components__WEBPACK_IMPORTED_MODULE_0__.Button, { className: `${NAVIGATION_BUTTON_CLASS} ${unreadAfter !== null ? NAVIGATION_UNREAD_CLASS : ''} ${NAVIGATION_BOTTOM_CLASS}`, onClick: () => gotoMessage(unreadAfter !== null ? unreadAfter : model.messages.length - 1), title: unreadAfter !== null
                ? 'Go to unread messages'
                : 'Go to last message' },
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.LabIcon.resolveReact, { display: 'flex', icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.caretDownEmptyIcon, iconClass: (0,_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.classes)('jp-Icon') })))));
}
/**
 * the avatar component.
 */
function Avatar(props) {
    const { user } = props;
    const sharedStyles = {
        height: `${props.small ? '16' : '24'}px`,
        width: `${props.small ? '16' : '24'}px`,
        bgcolor: user.color,
        fontSize: `var(--jp-ui-font-size${props.small ? '0' : '1'})`
    };
    return user.avatar_url ? (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
            ...sharedStyles
        }, src: user.avatar_url })) : user.initials ? (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
            ...sharedStyles
        } },
        react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { sx: {
                fontSize: `var(--jp-ui-font-size${props.small ? '0' : '1'})`,
                color: 'var(--jp-ui-inverse-font-color1)'
            } }, user.initials))) : null;
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/chat.js":
/*!**********************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/chat.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Chat: () => (/* binding */ Chat),
/* harmony export */   ChatBody: () => (/* binding */ ChatBody)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_ArrowBack__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/icons-material/ArrowBack */ "../../node_modules/@mui/icons-material/ArrowBack.js");
/* harmony import */ var _mui_icons_material_Settings__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/icons-material/Settings */ "../../node_modules/@mui/icons-material/Settings.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_system__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/system */ "../../node_modules/@mui/system/esm/Box/Box.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jl_theme_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./jl-theme-provider */ "../../packages/jupyter-chat/lib/components/jl-theme-provider.js");
/* harmony import */ var _chat_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./chat-messages */ "../../packages/jupyter-chat/lib/components/chat-messages.js");
/* harmony import */ var _chat_input__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./chat-input */ "../../packages/jupyter-chat/lib/components/chat-input.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */








function ChatBody(props) {
    const { model, rmRegistry: renderMimeRegistry, autocompletionRegistry } = props;
    // no need to append to messageGroups imperatively here. all of that is
    // handled by the listeners registered in the effect hooks above.
    const onSend = async (input) => {
        // send message to backend
        model.sendMessage({ body: input });
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_chat_messages__WEBPACK_IMPORTED_MODULE_1__.ChatMessages, { rmRegistry: renderMimeRegistry, model: model }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_chat_input__WEBPACK_IMPORTED_MODULE_2__.ChatInput, { onSend: onSend, sx: {
                paddingLeft: 4,
                paddingRight: 4,
                paddingTop: 3.5,
                paddingBottom: 0,
                borderTop: '1px solid var(--jp-border-color1)'
            }, model: model, autocompletionRegistry: autocompletionRegistry })));
}
function Chat(props) {
    var _a;
    const [view, setView] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(props.chatView || Chat.View.chat);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_jl_theme_provider__WEBPACK_IMPORTED_MODULE_3__.JlThemeProvider, { themeManager: (_a = props.themeManager) !== null && _a !== void 0 ? _a : null },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_system__WEBPACK_IMPORTED_MODULE_4__["default"]
        // root box should not include padding as it offsets the vertical
        // scrollbar to the left
        , { 
            // root box should not include padding as it offsets the vertical
            // scrollbar to the left
            sx: {
                width: '100%',
                height: '100%',
                boxSizing: 'border-box',
                background: 'var(--jp-layout-color0)',
                display: 'flex',
                flexDirection: 'column'
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_system__WEBPACK_IMPORTED_MODULE_4__["default"], { sx: { display: 'flex', justifyContent: 'space-between' } },
                view !== Chat.View.chat ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { onClick: () => setView(Chat.View.chat) },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ArrowBack__WEBPACK_IMPORTED_MODULE_6__["default"], null))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_system__WEBPACK_IMPORTED_MODULE_4__["default"], null)),
                view !== Chat.View.settings && props.settingsPanel ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { onClick: () => setView(Chat.View.settings) },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Settings__WEBPACK_IMPORTED_MODULE_7__["default"], null))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_system__WEBPACK_IMPORTED_MODULE_4__["default"], null))),
            view === Chat.View.chat && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(ChatBody, { model: props.model, rmRegistry: props.rmRegistry, autocompletionRegistry: props.autocompletionRegistry })),
            view === Chat.View.settings && props.settingsPanel && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(props.settingsPanel, null)))));
}
/**
 * The chat UI namespace
 */
(function (Chat) {
    /**
     * The view to render.
     * The settings view is available only if the settings panel is provided in options.
     */
    let View;
    (function (View) {
        View[View["chat"] = 0] = "chat";
        View[View["settings"] = 1] = "settings";
    })(View = Chat.View || (Chat.View = {}));
})(Chat || (Chat = {}));


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/code-blocks/code-toolbar.js":
/*!******************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/code-blocks/code-toolbar.js ***!
  \******************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CodeToolbar: () => (/* binding */ CodeToolbar)
/* harmony export */ });
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Box/Box.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _copy_button__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./copy-button */ "../../packages/jupyter-chat/lib/components/code-blocks/copy-button.js");
/* harmony import */ var _mui_extras_tooltipped_icon_button__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../mui-extras/tooltipped-icon-button */ "../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-icon-button.js");
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../../icons */ "../../packages/jupyter-chat/lib/icons.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */






const CODE_TOOLBAR_CLASS = 'jp-chat-code-toolbar';
const CODE_TOOLBAR_ITEM_CLASS = 'jp-chat-code-toolbar-item';
function CodeToolbar(props) {
    var _a;
    const { content, model } = props;
    const [toolbarEnable, setToolbarEnable] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)((_a = model.config.enableCodeToolbar) !== null && _a !== void 0 ? _a : true);
    const activeCellManager = model.activeCellManager;
    const selectionWatcher = model.selectionWatcher;
    const [toolbarBtnProps, setToolbarBtnProps] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)({
        content,
        activeCellManager,
        selectionWatcher,
        activeCellAvailable: !!(activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.available),
        selectionExists: !!(selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selection)
    });
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        const toggleToolbar = () => {
            var _a;
            setToolbarEnable((_a = model.config.enableCodeToolbar) !== null && _a !== void 0 ? _a : true);
        };
        const selectionStatusChange = () => {
            setToolbarBtnProps({
                content,
                activeCellManager,
                selectionWatcher,
                activeCellAvailable: !!(activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.available),
                selectionExists: !!(selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selection)
            });
        };
        activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.availabilityChanged.connect(selectionStatusChange);
        selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selectionChanged.connect(selectionStatusChange);
        model.configChanged.connect(toggleToolbar);
        selectionStatusChange();
        return () => {
            activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.availabilityChanged.disconnect(selectionStatusChange);
            selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selectionChanged.disconnect(selectionStatusChange);
            model.configChanged.disconnect(toggleToolbar);
        };
    }, [model]);
    return activeCellManager === null || !toolbarEnable ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null)) : (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { sx: {
            display: 'flex',
            justifyContent: 'flex-end',
            alignItems: 'center',
            padding: '6px 2px',
            marginBottom: '1em',
            border: '1px solid var(--jp-cell-editor-border-color)',
            borderTop: 'none'
        }, className: CODE_TOOLBAR_CLASS },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(InsertAboveButton, { ...toolbarBtnProps, className: CODE_TOOLBAR_ITEM_CLASS }),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(InsertBelowButton, { ...toolbarBtnProps, className: CODE_TOOLBAR_ITEM_CLASS }),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(ReplaceButton, { ...toolbarBtnProps, className: CODE_TOOLBAR_ITEM_CLASS }),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_copy_button__WEBPACK_IMPORTED_MODULE_3__.CopyButton, { value: content, className: CODE_TOOLBAR_ITEM_CLASS })));
}
function InsertAboveButton(props) {
    const tooltip = props.activeCellAvailable
        ? 'Insert above active cell'
        : 'Insert above active cell (no active cell)';
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_extras_tooltipped_icon_button__WEBPACK_IMPORTED_MODULE_4__.TooltippedIconButton, { className: props.className, tooltip: tooltip, onClick: () => { var _a; return (_a = props.activeCellManager) === null || _a === void 0 ? void 0 : _a.insertAbove(props.content); }, disabled: !props.activeCellAvailable },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.addAboveIcon.react, { height: "16px", width: "16px" })));
}
function InsertBelowButton(props) {
    const tooltip = props.activeCellAvailable
        ? 'Insert below active cell'
        : 'Insert below active cell (no active cell)';
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_extras_tooltipped_icon_button__WEBPACK_IMPORTED_MODULE_4__.TooltippedIconButton, { className: props.className, tooltip: tooltip, disabled: !props.activeCellAvailable, onClick: () => { var _a; return (_a = props.activeCellManager) === null || _a === void 0 ? void 0 : _a.insertBelow(props.content); } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.addBelowIcon.react, { height: "16px", width: "16px" })));
}
function ReplaceButton(props) {
    var _a, _b;
    const tooltip = props.selectionExists
        ? `Replace selection (${(_b = (_a = props.selectionWatcher) === null || _a === void 0 ? void 0 : _a.selection) === null || _b === void 0 ? void 0 : _b.numLines} line(s))`
        : props.activeCellAvailable
            ? 'Replace selection (active cell)'
            : 'Replace selection (no selection)';
    const disabled = !props.activeCellAvailable && !props.selectionExists;
    const replace = () => {
        var _a, _b, _c;
        if (props.selectionExists) {
            const selection = (_a = props.selectionWatcher) === null || _a === void 0 ? void 0 : _a.selection;
            if (!selection) {
                return;
            }
            (_b = props.selectionWatcher) === null || _b === void 0 ? void 0 : _b.replaceSelection({
                ...selection,
                text: props.content
            });
        }
        else if (props.activeCellAvailable) {
            (_c = props.activeCellManager) === null || _c === void 0 ? void 0 : _c.replace(props.content);
        }
    };
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_extras_tooltipped_icon_button__WEBPACK_IMPORTED_MODULE_4__.TooltippedIconButton, { className: props.className, tooltip: tooltip, disabled: disabled, onClick: replace },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_icons__WEBPACK_IMPORTED_MODULE_5__.replaceCellIcon.react, { height: "16px", width: "16px" })));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/code-blocks/copy-button.js":
/*!*****************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/code-blocks/copy-button.js ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CopyButton: () => (/* binding */ CopyButton)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _mui_extras_tooltipped_icon_button__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../mui-extras/tooltipped-icon-button */ "../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-icon-button.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */



var CopyStatus;
(function (CopyStatus) {
    CopyStatus[CopyStatus["None"] = 0] = "None";
    CopyStatus[CopyStatus["Copying"] = 1] = "Copying";
    CopyStatus[CopyStatus["Copied"] = 2] = "Copied";
})(CopyStatus || (CopyStatus = {}));
const COPYBTN_TEXT_BY_STATUS = {
    [CopyStatus.None]: 'Copy to clipboard',
    [CopyStatus.Copying]: 'Copying…',
    [CopyStatus.Copied]: 'Copied!'
};
function CopyButton(props) {
    const [copyStatus, setCopyStatus] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(CopyStatus.None);
    const timeoutId = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)(null);
    const copy = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(async () => {
        // ignore if we are already copying
        if (copyStatus === CopyStatus.Copying) {
            return;
        }
        try {
            await navigator.clipboard.writeText(props.value);
        }
        catch (err) {
            console.error('Failed to copy text: ', err);
            setCopyStatus(CopyStatus.None);
            return;
        }
        setCopyStatus(CopyStatus.Copied);
        if (timeoutId.current) {
            clearTimeout(timeoutId.current);
        }
        timeoutId.current = window.setTimeout(() => setCopyStatus(CopyStatus.None), 1000);
    }, [copyStatus, props.value]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_extras_tooltipped_icon_button__WEBPACK_IMPORTED_MODULE_2__.TooltippedIconButton, { className: props.className, tooltip: COPYBTN_TEXT_BY_STATUS[copyStatus], placement: "top", onClick: copy, "aria-label": "Copy to clipboard" },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_1__.copyIcon.react, { height: "16px", width: "16px" })));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/input/cancel-button.js":
/*!*************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/input/cancel-button.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CancelButton: () => (/* binding */ CancelButton)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Cancel__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/icons-material/Cancel */ "../../node_modules/@mui/icons-material/Cancel.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_extras_tooltipped_button__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../mui-extras/tooltipped-button */ "../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-button.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */



const CANCEL_BUTTON_CLASS = 'jp-chat-cancel-button';
/**
 * The cancel button.
 */
function CancelButton(props) {
    const tooltip = 'Cancel edition';
    const disabled = !props.inputExists;
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_extras_tooltipped_button__WEBPACK_IMPORTED_MODULE_1__.TooltippedButton, { onClick: props.onCancel, disabled: disabled, tooltip: tooltip, buttonProps: {
            size: 'small',
            variant: 'contained',
            title: tooltip,
            className: CANCEL_BUTTON_CLASS
        }, sx: {
            minWidth: 'unset',
            padding: '4px',
            borderRadius: '2px 0px 0px 2px',
            marginRight: '1px'
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Cancel__WEBPACK_IMPORTED_MODULE_2__["default"], null)));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/input/send-button.js":
/*!***********************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/input/send-button.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SendButton: () => (/* binding */ SendButton)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_KeyboardArrowDown__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/icons-material/KeyboardArrowDown */ "../../node_modules/@mui/icons-material/KeyboardArrowDown.js");
/* harmony import */ var _mui_icons_material_Send__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/icons-material/Send */ "../../node_modules/@mui/icons-material/Send.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Menu/Menu.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_extras_tooltipped_button__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../mui-extras/tooltipped-button */ "../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-button.js");
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../../icons */ "../../packages/jupyter-chat/lib/icons.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */






const SEND_BUTTON_CLASS = 'jp-chat-send-button';
const SEND_INCLUDE_OPENER_CLASS = 'jp-chat-send-include-opener';
const SEND_INCLUDE_LI_CLASS = 'jp-chat-send-include';
/**
 * The send button, with optional 'include selection' menu.
 */
function SendButton(props) {
    var _a, _b;
    const { activeCellManager, selectionWatcher } = props.model;
    const hideIncludeSelection = (_a = props.hideIncludeSelection) !== null && _a !== void 0 ? _a : false;
    const hasButtonOnLeft = (_b = props.hasButtonOnLeft) !== null && _b !== void 0 ? _b : false;
    const [menuAnchorEl, setMenuAnchorEl] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(null);
    const [menuOpen, setMenuOpen] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const openMenu = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((el) => {
        setMenuAnchorEl(el);
        setMenuOpen(true);
    }, []);
    const closeMenu = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        setMenuOpen(false);
    }, []);
    const disabled = !props.inputExists;
    const [selectionTooltip, setSelectionTooltip] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)('');
    const [disableInclude, setDisableInclude] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(true);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        /**
         * Enable or disable the include selection button, and adapt the tooltip.
         */
        const toggleIncludeState = () => {
            setDisableInclude(!((selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selection) || (activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.available)));
            const tooltip = (selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selection)
                ? `${selectionWatcher.selection.numLines} line(s) selected`
                : (activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.available)
                    ? 'Code from 1 active cell'
                    : 'No selection or active cell';
            setSelectionTooltip(tooltip);
        };
        if (!hideIncludeSelection) {
            selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selectionChanged.connect(toggleIncludeState);
            activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.availabilityChanged.connect(toggleIncludeState);
            toggleIncludeState();
        }
        return () => {
            selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selectionChanged.disconnect(toggleIncludeState);
            activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.availabilityChanged.disconnect(toggleIncludeState);
        };
    }, [activeCellManager, selectionWatcher, hideIncludeSelection]);
    const defaultTooltip = props.sendWithShiftEnter
        ? 'Send message (SHIFT+ENTER)'
        : 'Send message (ENTER)';
    const tooltip = defaultTooltip;
    function sendWithSelection() {
        // Append the selected text if exists.
        if (selectionWatcher === null || selectionWatcher === void 0 ? void 0 : selectionWatcher.selection) {
            props.onSend({
                type: 'text',
                source: selectionWatcher.selection.text
            });
            closeMenu();
            return;
        }
        // Append the active cell content if exists.
        if (activeCellManager === null || activeCellManager === void 0 ? void 0 : activeCellManager.available) {
            props.onSend({
                type: 'cell',
                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                source: activeCellManager.getContent(false).source
            });
            closeMenu();
            return;
        }
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"], { sx: { display: 'flex', flexWrap: 'nowrap' } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_extras_tooltipped_button__WEBPACK_IMPORTED_MODULE_2__.TooltippedButton, { onClick: () => props.onSend(), disabled: disabled, tooltip: tooltip, buttonProps: {
                size: 'small',
                title: defaultTooltip,
                variant: 'contained',
                className: SEND_BUTTON_CLASS
            }, sx: {
                minWidth: 'unset',
                borderTopLeftRadius: hasButtonOnLeft ? '0px' : '2px',
                borderTopRightRadius: hideIncludeSelection ? '2px' : '0px',
                borderBottomRightRadius: hideIncludeSelection ? '2px' : '0px',
                borderBottomLeftRadius: hasButtonOnLeft ? '0px' : '2px'
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Send__WEBPACK_IMPORTED_MODULE_3__["default"], null)),
        !hideIncludeSelection && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_extras_tooltipped_button__WEBPACK_IMPORTED_MODULE_2__.TooltippedButton, { onClick: e => {
                    openMenu(e.currentTarget);
                }, disabled: disabled, tooltip: "", buttonProps: {
                    variant: 'contained',
                    onKeyDown: e => {
                        if (e.key !== 'Enter' && e.key !== ' ') {
                            return;
                        }
                        openMenu(e.currentTarget);
                        // stopping propagation of this event prevents the prompt from being
                        // sent when the dropdown button is selected and clicked via 'Enter'.
                        e.stopPropagation();
                    },
                    className: SEND_INCLUDE_OPENER_CLASS
                }, sx: {
                    minWidth: 'unset',
                    padding: '4px 0px',
                    borderRadius: '0px 2px 2px 0px',
                    marginLeft: '1px'
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_KeyboardArrowDown__WEBPACK_IMPORTED_MODULE_4__["default"], null)),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { open: menuOpen, onClose: closeMenu, anchorEl: menuAnchorEl, anchorOrigin: {
                    vertical: 'top',
                    horizontal: 'right'
                }, transformOrigin: {
                    vertical: 'bottom',
                    horizontal: 'right'
                }, sx: {
                    '& .MuiMenuItem-root': {
                        display: 'flex',
                        alignItems: 'center',
                        gap: '8px'
                    },
                    '& svg': {
                        lineHeight: 0
                    }
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { onClick: e => {
                        sendWithSelection();
                        // prevent sending second message with no selection
                        e.stopPropagation();
                    }, disabled: disableInclude, className: SEND_INCLUDE_LI_CLASS },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_icons__WEBPACK_IMPORTED_MODULE_7__.includeSelectionIcon.react, null),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"], null,
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { display: "block" }, "Send message with selection"),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { display: "block", sx: { opacity: 0.618 } }, selectionTooltip))))))));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/jl-theme-provider.js":
/*!***********************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/jl-theme-provider.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JlThemeProvider: () => (/* binding */ JlThemeProvider)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mui/material/styles */ "../../node_modules/@mui/material/styles/createTheme.js");
/* harmony import */ var _mui_material_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material/styles */ "../../node_modules/@mui/material/styles/ThemeProvider.js");
/* harmony import */ var _theme_provider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../theme-provider */ "../../packages/jupyter-chat/lib/theme-provider.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */



function JlThemeProvider(props) {
    const [theme, setTheme] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)((0,_mui_material_styles__WEBPACK_IMPORTED_MODULE_1__["default"])());
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        var _a;
        async function setJlTheme() {
            setTheme(await (0,_theme_provider__WEBPACK_IMPORTED_MODULE_2__.getJupyterLabTheme)());
        }
        setJlTheme();
        (_a = props.themeManager) === null || _a === void 0 ? void 0 : _a.themeChanged.connect(setJlTheme);
    }, []);
    return react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_styles__WEBPACK_IMPORTED_MODULE_3__["default"], { theme: theme }, props.children);
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/mui-extras/contrasting-tooltip.js":
/*!************************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/mui-extras/contrasting-tooltip.js ***!
  \************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ContrastingTooltip: () => (/* binding */ ContrastingTooltip)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/styles/styled.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Tooltip/Tooltip.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Tooltip/tooltipClasses.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */


/**
 * A restyled MUI tooltip component that is dark by default to improve contrast
 * against JupyterLab's default light theme. TODO: support dark themes.
 */
const ContrastingTooltip = (0,_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"])(({ className, ...props }) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { ...props, arrow: true, classes: { popper: className } })))(({ theme }) => ({
    [`& .${_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"].tooltip}`]: {
        backgroundColor: theme.palette.common.black,
        color: theme.palette.common.white,
        boxShadow: theme.shadows[1],
        fontSize: 11
    },
    [`& .${_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"].arrow}`]: {
        color: theme.palette.common.black
    }
}));


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-button.js":
/*!**********************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-button.js ***!
  \**********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TooltippedButton: () => (/* binding */ TooltippedButton)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _contrasting_tooltip__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./contrasting-tooltip */ "../../packages/jupyter-chat/lib/components/mui-extras/contrasting-tooltip.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */



/**
 * A component that renders an MUI `Button` with a high-contrast tooltip
 * provided by `ContrastingTooltip`. This component differs from the MUI
 * defaults in the following ways:
 *
 * - Shows the tooltip on hover even if disabled.
 * - Renders the tooltip above the button by default.
 * - Renders the tooltip closer to the button by default.
 * - Lowers the opacity of the Button when disabled.
 * - Renders the Button with `line-height: 0` to avoid showing extra
 * vertical space in SVG icons.
 *
 * NOTE TO DEVS: Please keep this component's features synchronized with
 * features available to `TooltippedIconButton`.
 */
function TooltippedButton(props) {
    var _a;
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_contrasting_tooltip__WEBPACK_IMPORTED_MODULE_1__.ContrastingTooltip, { title: props.tooltip, placement: (_a = props.placement) !== null && _a !== void 0 ? _a : 'top', slotProps: {
            popper: {
                modifiers: [
                    {
                        name: 'offset',
                        options: {
                            offset: [0, -8]
                        }
                    }
                ]
            }
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { style: { cursor: 'default' } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { ...props.buttonProps, onClick: props.onClick, disabled: props.disabled, sx: {
                    lineHeight: 0,
                    ...(props.disabled && { opacity: 0.5 }),
                    ...props.sx
                }, "aria-label": props['aria-label'] }, props.children))));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-icon-button.js":
/*!***************************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/mui-extras/tooltipped-icon-button.js ***!
  \***************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TooltippedIconButton: () => (/* binding */ TooltippedIconButton)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _contrasting_tooltip__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./contrasting-tooltip */ "../../packages/jupyter-chat/lib/components/mui-extras/contrasting-tooltip.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */



/**
 * A component that renders an MUI `IconButton` with a high-contrast tooltip
 * provided by `ContrastingTooltip`. This component differs from the MUI
 * defaults in the following ways:
 *
 * - Shows the tooltip on hover even if disabled.
 * - Renders the tooltip above the button by default.
 * - Renders the tooltip closer to the button by default.
 * - Lowers the opacity of the IconButton when disabled.
 * - Renders the IconButton with `line-height: 0` to avoid showing extra
 * vertical space in SVG icons.
 */
function TooltippedIconButton(props) {
    var _a;
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_contrasting_tooltip__WEBPACK_IMPORTED_MODULE_1__.ContrastingTooltip, { title: props.tooltip, placement: (_a = props.placement) !== null && _a !== void 0 ? _a : 'top', slotProps: {
            popper: {
                modifiers: [
                    {
                        name: 'offset',
                        options: {
                            offset: [0, -8]
                        }
                    }
                ]
            }
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: props.className },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { ...props.iconButtonProps, onClick: props.onClick, disabled: props.disabled, sx: { lineHeight: 0, ...(props.disabled && { opacity: 0.5 }) }, "aria-label": props['aria-label'] }, props.children))));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/rendermime-markdown.js":
/*!*************************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/rendermime-markdown.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RendermimeMarkdown: () => (/* binding */ RendermimeMarkdown)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react-dom */ "webpack/sharing/consume/default/react-dom");
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _code_blocks_code_toolbar__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./code-blocks/code-toolbar */ "../../packages/jupyter-chat/lib/components/code-blocks/code-toolbar.js");
/* harmony import */ var _toolbar__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./toolbar */ "../../packages/jupyter-chat/lib/components/toolbar.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */




const MD_MIME_TYPE = 'text/markdown';
const RENDERMIME_MD_CLASS = 'jp-chat-rendermime-markdown';
/**
 * Takes \( and returns \\(. Escapes LaTeX delimeters by adding extra backslashes where needed for proper rendering by @jupyterlab/rendermime.
 */
function escapeLatexDelimiters(text) {
    return text
        .replace('\\(', '\\\\(')
        .replace('\\)', '\\\\)')
        .replace('\\[', '\\\\[')
        .replace('\\]', '\\\\]');
}
function RendermimeMarkdownBase(props) {
    const appendContent = props.appendContent || false;
    const [renderedContent, setRenderedContent] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(null);
    // each element is a two-tuple with the structure [codeToolbarRoot, codeToolbarProps].
    const [codeToolbarDefns, setCodeToolbarDefns] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        const renderContent = async () => {
            var _a;
            const mdStr = escapeLatexDelimiters(props.markdownStr);
            const model = props.rmRegistry.createModel({
                data: { [MD_MIME_TYPE]: mdStr }
            });
            const renderer = props.rmRegistry.createRenderer(MD_MIME_TYPE);
            await renderer.renderModel(model);
            (_a = props.rmRegistry.latexTypesetter) === null || _a === void 0 ? void 0 : _a.typeset(renderer.node);
            if (!renderer.node) {
                throw new Error('Rendermime was unable to render Markdown content within a chat message. Please report this upstream to Jupyter chat on GitHub.');
            }
            const newCodeToolbarDefns = [];
            // Attach CodeToolbar root element to each <pre> block
            const preBlocks = renderer.node.querySelectorAll('pre');
            preBlocks.forEach(preBlock => {
                var _a;
                const codeToolbarRoot = document.createElement('div');
                (_a = preBlock.parentNode) === null || _a === void 0 ? void 0 : _a.insertBefore(codeToolbarRoot, preBlock.nextSibling);
                newCodeToolbarDefns.push([
                    codeToolbarRoot,
                    { model: props.model, content: preBlock.textContent || '' }
                ]);
            });
            setCodeToolbarDefns(newCodeToolbarDefns);
            setRenderedContent(renderer.node);
        };
        renderContent();
    }, [props.markdownStr, props.rmRegistry]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: RENDERMIME_MD_CLASS },
        renderedContent &&
            (appendContent ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { ref: node => node && node.appendChild(renderedContent) })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { ref: node => node && node.replaceChildren(renderedContent) }))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_toolbar__WEBPACK_IMPORTED_MODULE_2__.MessageToolbar, { edit: props.edit, delete: props.delete }),
        // Render a `CodeToolbar` element underneath each code block.
        // We use ReactDOM.createPortal() so each `CodeToolbar` element is able
        // to use the context in the main React tree.
        codeToolbarDefns.map(codeToolbarDefn => {
            const [codeToolbarRoot, codeToolbarProps] = codeToolbarDefn;
            return (0,react_dom__WEBPACK_IMPORTED_MODULE_1__.createPortal)(react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_code_blocks_code_toolbar__WEBPACK_IMPORTED_MODULE_3__.CodeToolbar, { ...codeToolbarProps }), codeToolbarRoot);
        })));
}
const RendermimeMarkdown = react__WEBPACK_IMPORTED_MODULE_0___default().memo(RendermimeMarkdownBase);


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/scroll-container.js":
/*!**********************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/scroll-container.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ScrollContainer: () => (/* binding */ ScrollContainer)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Box/Box.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */


/**
 * Component that handles intelligent scrolling.
 *
 * - If viewport is at the bottom of the overflow container, appending new
 * children keeps the viewport on the bottom of the overflow container.
 *
 * - If viewport is in the middle of the overflow container, appending new
 * children leaves the viewport unaffected.
 *
 * Currently only works for Chrome and Firefox due to reliance on
 * `overflow-anchor`.
 *
 * **References**
 * - https://css-tricks.com/books/greatest-css-tricks/pin-scrolling-to-bottom/
 */
function ScrollContainer(props) {
    const id = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => 'jupyter-chat-scroll-container-' + Date.now().toString(), []);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"], { id: id, sx: {
            overflowY: 'scroll',
            '& *': {
                overflowAnchor: 'none'
            },
            ...props.sx
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"], { sx: { minHeight: '100.01%' } }, props.children),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"], { sx: { overflowAnchor: 'auto', height: '1px' } })));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/components/toolbar.js":
/*!*************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/components/toolbar.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MessageToolbar: () => (/* binding */ MessageToolbar)
/* harmony export */ });
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */


const TOOLBAR_CLASS = 'jp-chat-toolbar';
/**
 * The toolbar attached to a message.
 */
function MessageToolbar(props) {
    const buttons = [];
    if (props.edit !== undefined) {
        const editButton = (0,_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.ToolbarButtonComponent)({
            icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.editIcon,
            onClick: props.edit,
            tooltip: 'Edit'
        });
        buttons.push(editButton);
    }
    if (props.delete !== undefined) {
        const deleteButton = (0,_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.ToolbarButtonComponent)({
            icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.deleteIcon,
            onClick: props.delete,
            tooltip: 'Delete'
        });
        buttons.push(deleteButton);
    }
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", { className: TOOLBAR_CLASS }, buttons.map(toolbarButton => toolbarButton)));
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/icons.js":
/*!************************************************!*\
  !*** ../../packages/jupyter-chat/lib/icons.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   chatIcon: () => (/* binding */ chatIcon),
/* harmony export */   includeSelectionIcon: () => (/* binding */ includeSelectionIcon),
/* harmony export */   readIcon: () => (/* binding */ readIcon),
/* harmony export */   replaceCellIcon: () => (/* binding */ replaceCellIcon)
/* harmony export */ });
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _style_icons_chat_svg__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../style/icons/chat.svg */ "../../packages/jupyter-chat/style/icons/chat.svg");
/* harmony import */ var _style_icons_include_selection_svg__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../style/icons/include-selection.svg */ "../../packages/jupyter-chat/style/icons/include-selection.svg");
/* harmony import */ var _style_icons_read_svg__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../style/icons/read.svg */ "../../packages/jupyter-chat/style/icons/read.svg");
/* harmony import */ var _style_icons_replace_cell_svg__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../style/icons/replace-cell.svg */ "../../packages/jupyter-chat/style/icons/replace-cell.svg");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */
// This file is based on iconimports.ts in @jupyterlab/ui-components, but is manually generated.





const chatIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'jupyter-chat::chat',
    svgstr: _style_icons_chat_svg__WEBPACK_IMPORTED_MODULE_1__
});
const readIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'jupyter-chat::read',
    svgstr: _style_icons_read_svg__WEBPACK_IMPORTED_MODULE_2__
});
const replaceCellIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'jupyter-ai::replace-cell',
    svgstr: _style_icons_replace_cell_svg__WEBPACK_IMPORTED_MODULE_3__
});
const includeSelectionIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'jupyter-chat::include',
    svgstr: _style_icons_include_selection_svg__WEBPACK_IMPORTED_MODULE_4__
});


/***/ }),

/***/ "../../packages/jupyter-chat/lib/index.js":
/*!************************************************!*\
  !*** ../../packages/jupyter-chat/lib/index.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ActiveCellManager: () => (/* reexport safe */ _active_cell_manager__WEBPACK_IMPORTED_MODULE_3__.ActiveCellManager),
/* harmony export */   AutocompletionRegistry: () => (/* reexport safe */ _registry__WEBPACK_IMPORTED_MODULE_2__.AutocompletionRegistry),
/* harmony export */   ChatModel: () => (/* reexport safe */ _model__WEBPACK_IMPORTED_MODULE_1__.ChatModel),
/* harmony export */   ChatWidget: () => (/* reexport safe */ _widgets_chat_widget__WEBPACK_IMPORTED_MODULE_7__.ChatWidget),
/* harmony export */   IAutocompletionRegistry: () => (/* reexport safe */ _registry__WEBPACK_IMPORTED_MODULE_2__.IAutocompletionRegistry),
/* harmony export */   SelectionWatcher: () => (/* reexport safe */ _selection_watcher__WEBPACK_IMPORTED_MODULE_4__.SelectionWatcher),
/* harmony export */   buildChatSidebar: () => (/* reexport safe */ _widgets_chat_sidebar__WEBPACK_IMPORTED_MODULE_6__.buildChatSidebar),
/* harmony export */   buildErrorWidget: () => (/* reexport safe */ _widgets_chat_error__WEBPACK_IMPORTED_MODULE_5__.buildErrorWidget),
/* harmony export */   chatIcon: () => (/* reexport safe */ _icons__WEBPACK_IMPORTED_MODULE_0__.chatIcon),
/* harmony export */   includeSelectionIcon: () => (/* reexport safe */ _icons__WEBPACK_IMPORTED_MODULE_0__.includeSelectionIcon),
/* harmony export */   readIcon: () => (/* reexport safe */ _icons__WEBPACK_IMPORTED_MODULE_0__.readIcon),
/* harmony export */   replaceCellIcon: () => (/* reexport safe */ _icons__WEBPACK_IMPORTED_MODULE_0__.replaceCellIcon)
/* harmony export */ });
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./icons */ "../../packages/jupyter-chat/lib/icons.js");
/* harmony import */ var _model__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./model */ "../../packages/jupyter-chat/lib/model.js");
/* harmony import */ var _registry__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./registry */ "../../packages/jupyter-chat/lib/registry.js");
/* harmony import */ var _active_cell_manager__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./active-cell-manager */ "../../packages/jupyter-chat/lib/active-cell-manager.js");
/* harmony import */ var _selection_watcher__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./selection-watcher */ "../../packages/jupyter-chat/lib/selection-watcher.js");
/* harmony import */ var _widgets_chat_error__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./widgets/chat-error */ "../../packages/jupyter-chat/lib/widgets/chat-error.js");
/* harmony import */ var _widgets_chat_sidebar__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./widgets/chat-sidebar */ "../../packages/jupyter-chat/lib/widgets/chat-sidebar.js");
/* harmony import */ var _widgets_chat_widget__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./widgets/chat-widget */ "../../packages/jupyter-chat/lib/widgets/chat-widget.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */











/***/ }),

/***/ "../../packages/jupyter-chat/lib/model.js":
/*!************************************************!*\
  !*** ../../packages/jupyter-chat/lib/model.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChatModel: () => (/* binding */ ChatModel)
/* harmony export */ });
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_0__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */

/**
 * The default chat model implementation.
 * It is not able to send or update a message by itself, since it depends on the
 * chosen technology.
 */
class ChatModel {
    /**
     * Create a new chat model.
     */
    constructor(options = {}) {
        var _a, _b, _c;
        this._messages = [];
        this._unreadMessages = [];
        this._messagesInViewport = [];
        this._name = '';
        this._isDisposed = false;
        this._notificationId = null;
        this._messagesUpdated = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
        this._configChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
        this._unreadChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
        this._viewportChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
        this._writersChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
        this._focusInputSignal = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
        const config = (_a = options.config) !== null && _a !== void 0 ? _a : {};
        // Stack consecutive messages from the same user by default.
        this._config = {
            stackMessages: true,
            sendTypingNotification: true,
            ...config
        };
        this._commands = options.commands;
        this._activeCellManager = (_b = options.activeCellManager) !== null && _b !== void 0 ? _b : null;
        this._selectionWatcher = (_c = options.selectionWatcher) !== null && _c !== void 0 ? _c : null;
    }
    /**
     * The chat model id.
     */
    get id() {
        return this._id;
    }
    set id(value) {
        this._id = value;
    }
    /**
     * The chat model name.
     */
    get name() {
        return this._name;
    }
    set name(value) {
        this._name = value;
    }
    /**
     * The chat messages list.
     */
    get messages() {
        return this._messages;
    }
    /**
     * Get the active cell manager.
     */
    get activeCellManager() {
        return this._activeCellManager;
    }
    /**
     * Get the selection watcher.
     */
    get selectionWatcher() {
        return this._selectionWatcher;
    }
    /**
     * Timestamp of the last read message in local storage.
     */
    get lastRead() {
        var _a;
        if (this._id === undefined) {
            return 0;
        }
        const storage = JSON.parse(localStorage.getItem(`@jupyter/chat:${this._id}`) || '{}');
        return (_a = storage.lastRead) !== null && _a !== void 0 ? _a : 0;
    }
    set lastRead(value) {
        if (this._id === undefined) {
            return;
        }
        const storage = JSON.parse(localStorage.getItem(`@jupyter/chat:${this._id}`) || '{}');
        storage.lastRead = value;
        localStorage.setItem(`@jupyter/chat:${this._id}`, JSON.stringify(storage));
    }
    /**
     * The chat settings.
     */
    get config() {
        return this._config;
    }
    set config(value) {
        const stackMessagesChanged = 'stackMessages' in value &&
            this._config.stackMessages !== value.stackMessages;
        const unreadNotificationsChanged = 'unreadNotifications' in value &&
            this._config.unreadNotifications !== value.unreadNotifications;
        this._config = { ...this._config, ...value };
        this._configChanged.emit(this._config);
        // Update the stacked status of the messages and the view.
        if (stackMessagesChanged) {
            if (this._config.stackMessages) {
                this._messages.slice(1).forEach((message, idx) => {
                    const previousUser = this._messages[idx].sender.username;
                    message.stacked = previousUser === message.sender.username;
                });
            }
            else {
                this._messages.forEach(message => {
                    delete message.stacked;
                });
            }
            this._messagesUpdated.emit();
        }
        // remove existing notifications if they are not required anymore.
        if (unreadNotificationsChanged && !this._config.unreadNotifications) {
            this._notify(0);
        }
    }
    /**
     * The indexes list of the unread messages.
     */
    get unreadMessages() {
        return this._unreadMessages;
    }
    set unreadMessages(unread) {
        var _a;
        const recentlyRead = this._unreadMessages.filter(elem => !unread.includes(elem));
        const unreadCountDiff = unread.length - this._unreadMessages.length;
        this._unreadMessages = unread;
        this._unreadChanged.emit(this._unreadMessages);
        // Notify the change.
        this._notify(unread.length, unreadCountDiff > 0);
        // Save the last read to the local storage.
        if (this._id !== undefined && recentlyRead.length) {
            let lastReadChanged = false;
            let lastRead = (_a = this.lastRead) !== null && _a !== void 0 ? _a : this.messages[recentlyRead[0]].time;
            recentlyRead.forEach(index => {
                if (this.messages[index].time > lastRead) {
                    lastRead = this.messages[index].time;
                    lastReadChanged = true;
                }
            });
            if (lastReadChanged) {
                this.lastRead = lastRead;
            }
        }
    }
    /**
     * The indexes list of the messages currently in the viewport.
     */
    get messagesInViewport() {
        return this._messagesInViewport;
    }
    set messagesInViewport(values) {
        this._messagesInViewport = values;
        this._viewportChanged.emit(values);
    }
    /**
     * A signal emitting when the messages list is updated.
     */
    get messagesUpdated() {
        return this._messagesUpdated;
    }
    /**
     * A signal emitting when the messages list is updated.
     */
    get configChanged() {
        return this._configChanged;
    }
    /**
     * A signal emitting when unread messages change.
     */
    get unreadChanged() {
        return this._unreadChanged;
    }
    /**
     * A signal emitting when the viewport change.
     */
    get viewportChanged() {
        return this._viewportChanged;
    }
    /**
     * A signal emitting when the writers change.
     */
    get writersChanged() {
        return this._writersChanged;
    }
    /**
     * A signal emitting when the focus is requested on the input.
     */
    get focusInputSignal() {
        return this._focusInputSignal;
    }
    /**
     * Send a message, to be defined depending on the chosen technology.
     * Default to no-op.
     *
     * @param message - the message to send.
     * @returns whether the message has been sent or not.
     */
    sendMessage(message) { }
    /**
     * Dispose the chat model.
     */
    dispose() {
        if (this.isDisposed) {
            return;
        }
        this._isDisposed = true;
    }
    /**
     * Whether the chat handler is disposed.
     */
    get isDisposed() {
        return this._isDisposed;
    }
    /**
     * A function called before transferring the message to the panel(s).
     * Can be useful if some actions are required on the message.
     */
    formatChatMessage(message) {
        return message;
    }
    /**
     * Function to call when a message is received.
     *
     * @param message - the message with user information and body.
     */
    messageAdded(message) {
        const messageIndex = this._messages.findIndex(msg => msg.id === message.id);
        if (messageIndex > -1) {
            // The message is an update of an existing one.
            // Let's remove it to avoid position conflict if timestamp has changed.
            this._messages.splice(messageIndex, 1);
        }
        // Find the first message that should be after this one.
        let nextMsgIndex = this._messages.findIndex(msg => msg.time > message.time);
        if (nextMsgIndex === -1) {
            // There is no message after this one, so let's insert the message at the end.
            nextMsgIndex = this._messages.length;
        }
        // Insert the message.
        this.messagesInserted(nextMsgIndex, [message]);
    }
    /**
     * Function called when messages are inserted.
     *
     * @param index - the index of the first message of the list.
     * @param messages - the messages list.
     */
    messagesInserted(index, messages) {
        var _a;
        const formattedMessages = [];
        const unreadIndexes = [];
        const lastRead = (_a = this.lastRead) !== null && _a !== void 0 ? _a : 0;
        // Format the messages.
        messages.forEach((message, idx) => {
            formattedMessages.push(this.formatChatMessage(message));
            if (message.time > lastRead) {
                unreadIndexes.push(index + idx);
            }
        });
        // Insert the messages.
        this._messages.splice(index, 0, ...formattedMessages);
        if (this._config.stackMessages) {
            // Check if some messages should be stacked by comparing each message' sender
            // with the previous one.
            const lastIdx = index + formattedMessages.length - 1;
            const start = index === 0 ? 1 : index;
            const end = this._messages.length > lastIdx + 1 ? lastIdx + 1 : lastIdx;
            for (let idx = start; idx <= end; idx++) {
                const message = this._messages[idx];
                const previousUser = this._messages[idx - 1].sender.username;
                message.stacked = previousUser === message.sender.username;
            }
        }
        this._addUnreadMessages(unreadIndexes);
        this._messagesUpdated.emit();
    }
    /**
     * Function called when messages are deleted.
     *
     * @param index - the index of the first message to delete.
     * @param count - the number of messages to delete.
     */
    messagesDeleted(index, count) {
        this._messages.splice(index, count);
        this._messagesUpdated.emit();
    }
    /**
     * Update the current writers list.
     * This implementation only propagate the list via a signal.
     */
    updateWriters(writers) {
        this._writersChanged.emit(writers);
    }
    /**
     * Function to request the focus on the input of the chat.
     */
    focusInput() {
        this._focusInputSignal.emit();
    }
    /**
     * Function called by the input on key pressed.
     */
    inputChanged(input) { }
    /**
     * Add unread messages to the list.
     * @param indexes - list of new indexes.
     */
    _addUnreadMessages(indexes) {
        const unread = new Set(this._unreadMessages);
        indexes.forEach(index => unread.add(index));
        this.unreadMessages = Array.from(unread.values());
    }
    /**
     * Notifications on unread messages.
     *
     * @param unreadCount - number of unread messages.
     *    If the value is 0, existing notification will be deleted.
     * @param canCreate - whether to create a notification if it does not exist.
     *    Usually it is used when there are new unread messages, and not when the
     *    unread messages count decrease.
     */
    _notify(unreadCount, canCreate = false) {
        if (this._commands) {
            if (unreadCount && this._config.unreadNotifications) {
                // Update the notification if exist.
                this._commands
                    .execute('apputils:update-notification', {
                    id: this._notificationId,
                    message: `${unreadCount} incoming message(s) ${this._name ? 'in ' + this._name : ''}`
                })
                    .then(success => {
                    // Create a new notification only if messages are added.
                    if (!success && canCreate) {
                        this._commands.execute('apputils:notify', {
                            type: 'info',
                            message: `${unreadCount} incoming message(s) in ${this._name}`
                        }).then(id => {
                            this._notificationId = id;
                        });
                    }
                });
            }
            else if (this._notificationId) {
                // Delete notification if there is no more unread messages.
                this._commands.execute('apputils:dismiss-notification', {
                    id: this._notificationId
                });
                this._notificationId = null;
            }
        }
    }
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/registry.js":
/*!***************************************************!*\
  !*** ../../packages/jupyter-chat/lib/registry.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   AutocompletionRegistry: () => (/* binding */ AutocompletionRegistry),
/* harmony export */   IAutocompletionRegistry: () => (/* binding */ IAutocompletionRegistry)
/* harmony export */ });
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_0__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */

/**
 * The token for the autocomplete registry, which can be provided by an extension
 * using @jupyter/chat package.
 */
const IAutocompletionRegistry = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_0__.Token('@jupyter/chat:IAutocompleteRegistry');
/**
 * A registry to provide autocompleters.
 */
class AutocompletionRegistry {
    constructor() {
        this._default = null;
        this._autocompletions = new Map();
    }
    /**
     * Getter and setter for the default autocompletion name.
     */
    get default() {
        return this._default;
    }
    set default(name) {
        if (name === null || this._autocompletions.has(name)) {
            this._default = name;
        }
        else {
            console.warn(`There is no registered completer with the name '${name}'`);
        }
    }
    /**
     * Get the default autocompletion.
     */
    getDefaultCompletion() {
        if (this._default === null) {
            return undefined;
        }
        return this._autocompletions.get(this._default);
    }
    /**
     * Return a registered autocomplete props.
     *
     * @param name - the name of the registered autocomplete props.
     */
    get(name) {
        return this._autocompletions.get(name);
    }
    /**
     * Register autocomplete props.
     *
     * @param name - the name for the registration.
     * @param autocompletion - the autocomplete props.
     */
    add(name, autocompletion, isDefault = false) {
        if (!this._autocompletions.has(name)) {
            this._autocompletions.set(name, autocompletion);
            if (this._autocompletions.size === 1 || isDefault) {
                this.default = name;
            }
            return true;
        }
        else {
            console.warn(`A completer with the name '${name}' is already registered`);
            return false;
        }
    }
    /**
     * Remove a registered autocomplete props.
     *
     * @param name - the name of the autocomplete props.
     */
    remove(name) {
        return this._autocompletions.delete(name);
    }
    /**
     * Remove all registered autocompletions.
     */
    removeAll() {
        this._autocompletions.clear();
    }
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/selection-watcher.js":
/*!************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/selection-watcher.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SelectionWatcher: () => (/* binding */ SelectionWatcher)
/* harmony export */ });
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/docregistry */ "webpack/sharing/consume/default/@jupyterlab/docregistry");
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/algorithm */ "webpack/sharing/consume/default/@lumino/algorithm");
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_algorithm__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./utils */ "../../packages/jupyter-chat/lib/utils.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */





/**
 * The selection watcher, read/write selected text in a DocumentWidget.
 */
class SelectionWatcher {
    constructor(options) {
        var _a;
        this._mainAreaDocumentWidget = null;
        this._selection = null;
        this._selectionChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__.Signal(this);
        this._shell = options.shell;
        (_a = this._shell.currentChanged) === null || _a === void 0 ? void 0 : _a.connect((sender, args) => {
            var _a;
            // Do not change the main area widget if the new one has no editor, for example
            // a chat panel. However, the selected text is only available if the main area
            // widget is visible. (to avoid confusion in inclusion/replacement).
            const widget = args.newValue;
            // if there is no main area widget, set it to null.
            if (widget === null) {
                this._mainAreaDocumentWidget = null;
                return;
            }
            const editor = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getEditor)(widget);
            if (widget instanceof _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_0__.DocumentWidget &&
                (editor || widget.content instanceof _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.Notebook)) {
                // if the new widget is a DocumentWidget and has an editor, set it.
                // NOTE: special case for notebook which do not has an active cell at that stage,
                // and so the editor can't be retrieved too.
                this._mainAreaDocumentWidget = widget;
            }
            else if ((_a = this._mainAreaDocumentWidget) === null || _a === void 0 ? void 0 : _a.isDisposed) {
                // if the previous document widget has been closed, set it to null.
                this._mainAreaDocumentWidget = null;
            }
        });
        setInterval(this._poll.bind(this), 200);
    }
    get selection() {
        return this._selection;
    }
    get selectionChanged() {
        return this._selectionChanged;
    }
    replaceSelection(selection) {
        // unfortunately shell.currentWidget doesn't update synchronously after
        // shell.activateById(), which is why we have to get a reference to the
        // widget manually.
        const widget = (0,_lumino_algorithm__WEBPACK_IMPORTED_MODULE_2__.find)(this._shell.widgets(), widget => widget.id === selection.widgetId);
        // Do not allow replacement on non visible widget (to avoid confusion).
        if (!(widget === null || widget === void 0 ? void 0 : widget.isVisible) || !(widget instanceof _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_0__.DocumentWidget)) {
            return;
        }
        // activate the widget if not already active
        this._shell.activateById(selection.widgetId);
        // activate notebook cell if specified
        if (widget.content instanceof _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.Notebook && selection.cellId) {
            const cellIndex = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getCellIndex)(widget.content, selection.cellId);
            if (cellIndex !== -1) {
                widget.content.activeCellIndex = cellIndex;
            }
        }
        // get editor instance
        const editor = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getEditor)(widget);
        if (!editor) {
            return;
        }
        editor.model.sharedModel.updateSource(editor.getOffsetAt(selection.start), editor.getOffsetAt(selection.end), selection.text);
        const newPosition = editor.getPositionAt(editor.getOffsetAt(selection.start) + selection.text.length);
        editor.setSelection({ start: newPosition, end: newPosition });
    }
    _poll() {
        var _a;
        let currSelection = null;
        const prevSelection = this._selection;
        // Do not return selected text if the main area widget is hidden.
        if ((_a = this._mainAreaDocumentWidget) === null || _a === void 0 ? void 0 : _a.isVisible) {
            currSelection = getTextSelection(this._mainAreaDocumentWidget);
        }
        if ((prevSelection === null || prevSelection === void 0 ? void 0 : prevSelection.text) !== (currSelection === null || currSelection === void 0 ? void 0 : currSelection.text)) {
            this._selection = currSelection;
            this._selectionChanged.emit(currSelection);
        }
    }
}
/**
 * Gets a Selection object from a document widget. Returns `null` if unable.
 */
function getTextSelection(widget) {
    var _a;
    const editor = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getEditor)(widget);
    // widget type check is redundant but hints the type to TypeScript
    if (!editor || !(widget instanceof _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_0__.DocumentWidget)) {
        return null;
    }
    let cellId = undefined;
    if (widget.content instanceof _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.Notebook) {
        cellId = (_a = widget.content.activeCell) === null || _a === void 0 ? void 0 : _a.model.id;
    }
    const selectionObj = editor.getSelection();
    let { start, end } = selectionObj;
    const startOffset = editor.getOffsetAt(start);
    const endOffset = editor.getOffsetAt(end);
    const text = editor.model.sharedModel
        .getSource()
        .substring(startOffset, endOffset);
    // Do not return a Selection object if no text is selected
    if (!text) {
        return null;
    }
    // ensure start <= end
    // required for editor.model.sharedModel.updateSource()
    if (startOffset > endOffset) {
        [start, end] = [end, start];
    }
    return {
        ...selectionObj,
        start,
        end,
        text,
        numLines: text.split('\n').length,
        widgetId: widget.id,
        ...(cellId && {
            cellId
        })
    };
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/theme-provider.js":
/*!*********************************************************!*\
  !*** ../../packages/jupyter-chat/lib/theme-provider.js ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getJupyterLabTheme: () => (/* binding */ getJupyterLabTheme),
/* harmony export */   pollUntilReady: () => (/* binding */ pollUntilReady)
/* harmony export */ });
/* harmony import */ var _mui_material_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @mui/material/styles */ "../../node_modules/@mui/material/styles/createTheme.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */

function getCSSVariable(name) {
    return getComputedStyle(document.body).getPropertyValue(name).trim();
}
async function pollUntilReady() {
    while (!document.body.hasAttribute('data-jp-theme-light')) {
        await new Promise(resolve => setTimeout(resolve, 100)); // Wait 100ms
    }
}
async function getJupyterLabTheme() {
    await pollUntilReady();
    const light = document.body.getAttribute('data-jp-theme-light');
    return (0,_mui_material_styles__WEBPACK_IMPORTED_MODULE_0__["default"])({
        spacing: 4,
        components: {
            MuiButton: {
                defaultProps: {
                    size: 'small'
                }
            },
            MuiFilledInput: {
                defaultProps: {
                    margin: 'dense'
                }
            },
            MuiFormControl: {
                defaultProps: {
                    margin: 'dense',
                    size: 'small'
                }
            },
            MuiFormHelperText: {
                defaultProps: {
                    margin: 'dense'
                }
            },
            MuiIconButton: {
                defaultProps: {
                    size: 'small'
                }
            },
            MuiInputBase: {
                defaultProps: {
                    margin: 'dense',
                    size: 'small'
                }
            },
            MuiInputLabel: {
                defaultProps: {
                    margin: 'dense'
                }
            },
            MuiListItem: {
                defaultProps: {
                    dense: true
                }
            },
            MuiOutlinedInput: {
                defaultProps: {
                    margin: 'dense'
                }
            },
            MuiFab: {
                defaultProps: {
                    size: 'small'
                }
            },
            MuiTable: {
                defaultProps: {
                    size: 'small'
                }
            },
            MuiTextField: {
                defaultProps: {
                    margin: 'dense',
                    size: 'small'
                }
            },
            MuiToolbar: {
                defaultProps: {
                    variant: 'dense'
                }
            }
        },
        palette: {
            background: {
                paper: getCSSVariable('--jp-layout-color1'),
                default: getCSSVariable('--jp-layout-color1')
            },
            mode: light === 'true' ? 'light' : 'dark',
            primary: {
                main: getCSSVariable('--jp-brand-color1'),
                light: getCSSVariable('--jp-brand-color2'),
                dark: getCSSVariable('--jp-brand-color0')
            },
            error: {
                main: getCSSVariable('--jp-error-color1'),
                light: getCSSVariable('--jp-error-color2'),
                dark: getCSSVariable('--jp-error-color0')
            },
            warning: {
                main: getCSSVariable('--jp-warn-color1'),
                light: getCSSVariable('--jp-warn-color2'),
                dark: getCSSVariable('--jp-warn-color0')
            },
            success: {
                main: getCSSVariable('--jp-success-color1'),
                light: getCSSVariable('--jp-success-color2'),
                dark: getCSSVariable('--jp-success-color0')
            },
            text: {
                primary: getCSSVariable('--jp-ui-font-color1'),
                secondary: getCSSVariable('--jp-ui-font-color2'),
                disabled: getCSSVariable('--jp-ui-font-color3')
            }
        },
        shape: {
            borderRadius: 2
        },
        typography: {
            fontFamily: getCSSVariable('--jp-ui-font-family'),
            fontSize: 12,
            htmlFontSize: 16,
            button: {
                textTransform: 'capitalize'
            }
        }
    });
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/utils.js":
/*!************************************************!*\
  !*** ../../packages/jupyter-chat/lib/utils.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getCellIndex: () => (/* binding */ getCellIndex),
/* harmony export */   getEditor: () => (/* binding */ getEditor)
/* harmony export */ });
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/codemirror */ "webpack/sharing/consume/default/@jupyterlab/codemirror");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/docregistry */ "webpack/sharing/consume/default/@jupyterlab/docregistry");
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/fileeditor */ "webpack/sharing/consume/default/@jupyterlab/fileeditor");
/* harmony import */ var _jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */




/**
 * Gets the editor instance used by a document widget. Returns `null` if unable.
 */
function getEditor(widget) {
    var _a;
    if (!(widget instanceof _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1__.DocumentWidget)) {
        return null;
    }
    let editor;
    const { content } = widget;
    if (content instanceof _jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_2__.FileEditor) {
        editor = content.editor;
    }
    else if (content instanceof _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3__.Notebook) {
        editor = (_a = content.activeCell) === null || _a === void 0 ? void 0 : _a.editor;
    }
    if (!(editor instanceof _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_0__.CodeMirrorEditor)) {
        return undefined;
    }
    return editor;
}
/**
 * Gets the index of the cell associated with `cellId`.
 */
function getCellIndex(notebook, cellId) {
    var _a;
    const idx = (_a = notebook.model) === null || _a === void 0 ? void 0 : _a.sharedModel.cells.findIndex(cell => cell.getId() === cellId);
    return idx === undefined ? -1 : idx;
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/widgets/chat-error.js":
/*!*************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/widgets/chat-error.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   buildErrorWidget: () => (/* binding */ buildErrorWidget)
/* harmony export */ });
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../../node_modules/@mui/material/Alert/Alert.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _components_jl_theme_provider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../components/jl-theme-provider */ "../../packages/jupyter-chat/lib/components/jl-theme-provider.js");
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../icons */ "../../packages/jupyter-chat/lib/icons.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */





function buildErrorWidget(themeManager) {
    const ErrorWidget = _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.ReactWidget.create(react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_components_jl_theme_provider__WEBPACK_IMPORTED_MODULE_2__.JlThemeProvider, { themeManager: themeManager },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { sx: {
                width: '100%',
                height: '100%',
                boxSizing: 'border-box',
                background: 'var(--jp-layout-color0)',
                display: 'flex',
                flexDirection: 'column'
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { sx: { padding: 4 } },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { severity: "error" }, "There seems to be a problem with the Chat backend, please look at the JupyterLab server logs or contact your administrator to correct this problem.")))));
    ErrorWidget.id = 'jupyter-chat::chat';
    ErrorWidget.title.icon = _icons__WEBPACK_IMPORTED_MODULE_5__.chatIcon;
    ErrorWidget.title.caption = 'Jupyter Chat'; // TODO: i18n
    return ErrorWidget;
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/widgets/chat-sidebar.js":
/*!***************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/widgets/chat-sidebar.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   buildChatSidebar: () => (/* binding */ buildChatSidebar)
/* harmony export */ });
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _components_chat__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../components/chat */ "../../packages/jupyter-chat/lib/components/chat.js");
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "../../packages/jupyter-chat/lib/icons.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */




function buildChatSidebar(options) {
    const ChatWidget = _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.ReactWidget.create(react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_components_chat__WEBPACK_IMPORTED_MODULE_2__.Chat, { ...options }));
    ChatWidget.id = 'jupyter-chat::side-panel';
    ChatWidget.title.icon = _icons__WEBPACK_IMPORTED_MODULE_3__.chatIcon;
    ChatWidget.title.caption = 'Jupyter Chat'; // TODO: i18n
    return ChatWidget;
}


/***/ }),

/***/ "../../packages/jupyter-chat/lib/widgets/chat-widget.js":
/*!**************************************************************!*\
  !*** ../../packages/jupyter-chat/lib/widgets/chat-widget.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChatWidget: () => (/* binding */ ChatWidget)
/* harmony export */ });
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _components_chat__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../components/chat */ "../../packages/jupyter-chat/lib/components/chat.js");
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../icons */ "../../packages/jupyter-chat/lib/icons.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */




class ChatWidget extends _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.ReactWidget {
    constructor(options) {
        super();
        this.id = 'jupyter-chat::widget';
        this.title.icon = _icons__WEBPACK_IMPORTED_MODULE_2__.chatIcon;
        this.title.caption = 'Jupyter Chat'; // TODO: i18n
        this._chatOptions = options;
    }
    /**
     * Get the model of the widget.
     */
    get model() {
        return this._chatOptions.model;
    }
    render() {
        // The model need to be passed, otherwise it is undefined in the widget in
        // the case of collaborative document.
        return react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_components_chat__WEBPACK_IMPORTED_MODULE_3__.Chat, { ...this._chatOptions, model: this._chatOptions.model });
    }
}


/***/ }),

/***/ "../../packages/jupyter-chat/style/icons/chat.svg":
/*!********************************************************!*\
  !*** ../../packages/jupyter-chat/style/icons/chat.svg ***!
  \********************************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" height=\"16\" viewBox=\"0 0 24 24\" width=\"16\">\n  <g class=\"jp-icon3\" fill=\"#616161\">\n    <path d=\"M0 0h24v24H0V0z\" fill=\"none\"/>\n    <path d=\"M15 4v7H5.17L4 12.17V4h11m1-2H3c-.55 0-1 .45-1 1v14l4-4h10c.55 0 1-.45 1-1V3c0-.55-.45-1-1-1zm5 4h-2v9H6v2c0 .55.45 1 1 1h11l4 4V7c0-.55-.45-1-1-1z\"/>\n  </g>\n</svg>\n";

/***/ }),

/***/ "../../packages/jupyter-chat/style/icons/include-selection.svg":
/*!*********************************************************************!*\
  !*** ../../packages/jupyter-chat/style/icons/include-selection.svg ***!
  \*********************************************************************/
/***/ ((module) => {

module.exports = "<svg width=\"18\" height=\"9\" viewBox=\"0 0 18 9\" fill=\"none\" xmlns=\"http://www.w3.org/2000/svg\">\n    <path fill-rule=\"evenodd\" clip-rule=\"evenodd\"\n        d=\"M-0.0018417 1.33824L0.837379 0.499023L1.35717 1.01871C1.35741 1.01862 1.35764 1.01853 1.35787 1.01845L3.411 3.07158H3.41049L4.83909 4.49987L3.41011 5.92872H3.41075L1.35769 7.98178C1.35749 7.98171 1.35729 7.98164 1.35709 7.98156L0.837023 8.50158L-0.00219727 7.66236L3.1547 4.49987L-0.0018417 1.33824ZM2.6821 8.07158H16.143C16.932 8.07158 17.5716 7.43201 17.5716 6.64301V2.35729C17.5716 1.56832 16.932 0.928721 16.143 0.928721H2.68236L4.82522 3.07158H15.4287V5.92872H4.82496L2.6821 8.07158ZM1.74238 4.50002L0.428719 5.81655V3.18349L1.74238 4.50002Z\"\n        fill=\"#757575\" />\n</svg>\n";

/***/ }),

/***/ "../../packages/jupyter-chat/style/icons/read.svg":
/*!********************************************************!*\
  !*** ../../packages/jupyter-chat/style/icons/read.svg ***!
  \********************************************************/
/***/ ((module) => {

module.exports = "<svg height=\"24px\" viewBox=\"0 0 24 24\" width=\"24px\" xmlns=\"http://www.w3.org/2000/svg\">\n  <g>\n    <path\n       style=\"display:inline;fill:none;fill-opacity:1;stroke:#545454;stroke-width:1.54693;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1.5;stroke-dasharray:none;stroke-opacity:1;paint-order:normal\"\n       d=\"M 2.2734634,9 V 20.226537 H 21.726536 V 9\" />\n    <path\n       style=\"display:inline;fill:none;stroke:#545454;stroke-width:1.54528;stroke-linecap:square;stroke-miterlimit:10\"\n       transform=\"matrix(0.81805878,0.57513462,-0.81805878,0.57513462,0,0)\"\n       d=\"M 9.5141659,-5.1535239 H 20.802967 V 6.1352773 H 9.5141659 Z\" />\n  </g>\n</svg>\n";

/***/ }),

/***/ "../../packages/jupyter-chat/style/icons/replace-cell.svg":
/*!****************************************************************!*\
  !*** ../../packages/jupyter-chat/style/icons/replace-cell.svg ***!
  \****************************************************************/
/***/ ((module) => {

module.exports = "<svg width=\"16\" height=\"16\" viewBox=\"0 0 16 16\" fill=\"none\" xmlns=\"http://www.w3.org/2000/svg\">\n    <path fill-rule=\"evenodd\" clip-rule=\"evenodd\"\n        d=\"M12 4.71429V7H1.71429V4.71429H12ZM12.5714 3C13.2026 3 13.7143 3.51168 13.7143 4.14286V7.57143C13.7143 8.20263 13.2026 8.71429 12.5714 8.71429H1.14286C0.51168 8.71429 0 8.20263 0 7.57143V4.14286C0 3.51168 0.511669 3 1.14286 3H12.5714Z\"\n        fill=\"#565656\" />\n    <path fill-rule=\"evenodd\" clip-rule=\"evenodd\"\n        d=\"M14 8.71429V11H3.71429V8.71429H14ZM14.5714 7C15.2026 7 15.7143 7.51168 15.7143 8.14286V11.5714C15.7143 12.2026 15.2026 12.7143 14.5714 12.7143H3.14286C2.51168 12.7143 2 12.2026 2 11.5714V8.14286C2 7.51168 2.51167 7 3.14286 7H14.5714Z\"\n        fill=\"#565656\" />\n</svg>\n";

/***/ })

}]);
//# sourceMappingURL=packages_jupyter-chat_lib_index_js.cd3cb872bd49b5e2fb89.js.map