"use strict";
(self["webpackChunkjupyterlab_collaborative_chat_extension"] = self["webpackChunkjupyterlab_collaborative_chat_extension"] || []).push([["packages_jupyterlab-collaborative-chat_lib_index_js"],{

/***/ "../../packages/jupyterlab-collaborative-chat/lib/factory.js":
/*!*******************************************************************!*\
  !*** ../../packages/jupyterlab-collaborative-chat/lib/factory.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChatWidgetFactory: () => (/* binding */ ChatWidgetFactory),
/* harmony export */   CollaborativeChatModelFactory: () => (/* binding */ CollaborativeChatModelFactory),
/* harmony export */   WidgetConfig: () => (/* binding */ WidgetConfig)
/* harmony export */ });
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter/chat */ "webpack/sharing/consume/default/@jupyter/chat/@jupyter/chat?4f0c");
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_chat__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/docregistry */ "webpack/sharing/consume/default/@jupyterlab/docregistry");
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _model__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./model */ "../../packages/jupyterlab-collaborative-chat/lib/model.js");
/* harmony import */ var _widget__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./widget */ "../../packages/jupyterlab-collaborative-chat/lib/widget.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */





/**
 * The object provided by the chatDocument extension.
 * It is used to set the current config (from settings) to newly created chat widget,
 * and to propagate every changes to the existing chat widgets.
 */
class WidgetConfig {
    /**
     * The constructor of the WidgetConfig.
     */
    constructor(config) {
        this._configChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this);
        this._config = config;
    }
    /**
     * Getter and setter for the config.
     */
    get config() {
        return this._config;
    }
    set config(value) {
        this._config = { ...this._config, ...value };
        this._configChanged.emit(value);
    }
    /**
     * Getter for the configChanged signal
     */
    get configChanged() {
        return this._configChanged;
    }
}
/**
 * A widget factory to create new instances of CollaborativeChatWidget.
 */
class ChatWidgetFactory extends _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_1__.ABCWidgetFactory {
    /**
     * Constructor of ChatWidgetFactory.
     *
     * @param options Constructor options
     */
    constructor(options) {
        super(options);
        this._themeManager = options.themeManager;
        this._rmRegistry = options.rmRegistry;
        this._autocompletionRegistry = options.autocompletionRegistry;
    }
    /**
     * Create a new widget given a context.
     *
     * @param context Contains the information of the file
     * @returns The widget
     */
    createNewWidget(context) {
        context.rmRegistry = this._rmRegistry;
        context.themeManager = this._themeManager;
        context.autocompletionRegistry = this._autocompletionRegistry;
        return new _widget__WEBPACK_IMPORTED_MODULE_3__.CollaborativeChatPanel({
            context,
            content: new _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__.ChatWidget(context)
        });
    }
}
class CollaborativeChatModelFactory {
    constructor(options) {
        var _a, _b;
        this.collaborative = true;
        this._disposed = false;
        this._user = options.user;
        this._widgetConfig = options.widgetConfig;
        this._commands = options.commands;
        this._activeCellManager = (_a = options.activeCellManager) !== null && _a !== void 0 ? _a : null;
        this._selectionWatcher = (_b = options.selectionWatcher) !== null && _b !== void 0 ? _b : null;
    }
    /**
     * The name of the model.
     *
     * @returns The name
     */
    get name() {
        return 'chat';
    }
    /**
     * The content type of the file.
     *
     * @returns The content type
     */
    get contentType() {
        return 'chat';
    }
    /**
     * The format of the file.
     *
     * @returns the file format
     */
    get fileFormat() {
        return 'text';
    }
    /**
     * Get whether the model factory has been disposed.
     *
     * @returns disposed status
     */
    get isDisposed() {
        return this._disposed;
    }
    /**
     * Dispose the model factory.
     */
    dispose() {
        this._disposed = true;
    }
    /**
     * Get the preferred language given the path on the file.
     *
     * @param path path of the file represented by this document model
     * @returns The preferred language
     */
    preferredLanguage(path) {
        return '';
    }
    /**
     * Create a new instance of CollaborativeChatModel.
     *
     * @param languagePreference Language
     * @param modelDB Model database
     * @returns The model
     */
    createNew(options) {
        return new _model__WEBPACK_IMPORTED_MODULE_4__.CollaborativeChatModel({
            ...options,
            user: this._user,
            widgetConfig: this._widgetConfig,
            commands: this._commands,
            activeCellManager: this._activeCellManager,
            selectionWatcher: this._selectionWatcher
        });
    }
}


/***/ }),

/***/ "../../packages/jupyterlab-collaborative-chat/lib/index.js":
/*!*****************************************************************!*\
  !*** ../../packages/jupyterlab-collaborative-chat/lib/index.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChatPanel: () => (/* reexport safe */ _widget__WEBPACK_IMPORTED_MODULE_3__.ChatPanel),
/* harmony export */   ChatWidgetFactory: () => (/* reexport safe */ _factory__WEBPACK_IMPORTED_MODULE_0__.ChatWidgetFactory),
/* harmony export */   CollaborativeChatModel: () => (/* reexport safe */ _model__WEBPACK_IMPORTED_MODULE_1__.CollaborativeChatModel),
/* harmony export */   CollaborativeChatModelFactory: () => (/* reexport safe */ _factory__WEBPACK_IMPORTED_MODULE_0__.CollaborativeChatModelFactory),
/* harmony export */   CollaborativeChatPanel: () => (/* reexport safe */ _widget__WEBPACK_IMPORTED_MODULE_3__.CollaborativeChatPanel),
/* harmony export */   CommandIDs: () => (/* reexport safe */ _token__WEBPACK_IMPORTED_MODULE_2__.CommandIDs),
/* harmony export */   IActiveCellManagerToken: () => (/* reexport safe */ _token__WEBPACK_IMPORTED_MODULE_2__.IActiveCellManagerToken),
/* harmony export */   IChatFactory: () => (/* reexport safe */ _token__WEBPACK_IMPORTED_MODULE_2__.IChatFactory),
/* harmony export */   IChatPanel: () => (/* reexport safe */ _token__WEBPACK_IMPORTED_MODULE_2__.IChatPanel),
/* harmony export */   ISelectionWatcherToken: () => (/* reexport safe */ _token__WEBPACK_IMPORTED_MODULE_2__.ISelectionWatcherToken),
/* harmony export */   WidgetConfig: () => (/* reexport safe */ _factory__WEBPACK_IMPORTED_MODULE_0__.WidgetConfig),
/* harmony export */   YChat: () => (/* reexport safe */ _ychat__WEBPACK_IMPORTED_MODULE_4__.YChat),
/* harmony export */   chatFileType: () => (/* reexport safe */ _token__WEBPACK_IMPORTED_MODULE_2__.chatFileType)
/* harmony export */ });
/* harmony import */ var _factory__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./factory */ "../../packages/jupyterlab-collaborative-chat/lib/factory.js");
/* harmony import */ var _model__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./model */ "../../packages/jupyterlab-collaborative-chat/lib/model.js");
/* harmony import */ var _token__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./token */ "../../packages/jupyterlab-collaborative-chat/lib/token.js");
/* harmony import */ var _widget__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./widget */ "../../packages/jupyterlab-collaborative-chat/lib/widget.js");
/* harmony import */ var _ychat__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./ychat */ "../../packages/jupyterlab-collaborative-chat/lib/ychat.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */







/***/ }),

/***/ "../../packages/jupyterlab-collaborative-chat/lib/model.js":
/*!*****************************************************************!*\
  !*** ../../packages/jupyterlab-collaborative-chat/lib/model.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CollaborativeChatModel: () => (/* binding */ CollaborativeChatModel)
/* harmony export */ });
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter/chat */ "webpack/sharing/consume/default/@jupyter/chat/@jupyter/chat?4f0c");
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_chat__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _ychat__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./ychat */ "../../packages/jupyterlab-collaborative-chat/lib/ychat.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */




const WRITING_DELAY = 1000;
/**
 * The collaborative chat model.
 */
class CollaborativeChatModel extends _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__.ChatModel {
    constructor(options) {
        super(options);
        this.collaborative = true;
        /**
         * Triggered when an awareness state changes.
         * Used to populate the writers list.
         */
        this.onAwarenessChange = () => {
            const writers = [];
            const states = this.sharedModel.awareness.getStates();
            for (const stateID of states.keys()) {
                const state = states.get(stateID);
                if (!state || !state.user || state.user.username === this.user.username) {
                    continue;
                }
                if (state.isWriting) {
                    writers.push(state.user);
                }
            }
            this.updateWriters(writers);
        };
        this._onchange = (_, changes) => {
            if (changes.messageChanges) {
                const msgDelta = changes.messageChanges;
                let index = 0;
                msgDelta.forEach(delta => {
                    if (delta.retain) {
                        index += delta.retain;
                    }
                    else if (delta.insert) {
                        const messages = delta.insert.map(ymessage => {
                            const msg = {
                                ...ymessage,
                                sender: this.sharedModel.getUser(ymessage.sender) || {
                                    username: 'User undefined'
                                }
                            };
                            return msg;
                        });
                        this.messagesInserted(index, messages);
                        index += messages.length;
                    }
                    else if (delta.delete) {
                        this.messagesDeleted(index, delta.delete);
                    }
                });
            }
            if (changes.metadataChanges) {
                changes.metadataChanges.forEach(change => {
                    // no need to search for update or add, if the new value contains ID, let's
                    // update the model ID.
                    if (change.key === 'id') {
                        this.id = change.newValue;
                    }
                });
            }
        };
        this.defaultKernelName = '';
        this.defaultKernelLanguage = '';
        this._dirty = false;
        this._readOnly = false;
        this._disposed = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this);
        this._contentChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this);
        this._stateChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this);
        this._timeoutWriting = null;
        this._user = options.user || { username: 'user undefined' };
        const { widgetConfig, sharedModel } = options;
        if (sharedModel) {
            this._sharedModel = sharedModel;
        }
        else {
            this._sharedModel = _ychat__WEBPACK_IMPORTED_MODULE_3__.YChat.create();
        }
        this.id = this._sharedModel.id;
        this.sharedModel.changed.connect(this._onchange, this);
        this.config = widgetConfig.config;
        widgetConfig.configChanged.connect((_, config) => {
            this.config = config;
        });
        this.sharedModel.awareness.on('change', this.onAwarenessChange);
    }
    get user() {
        return this._user;
    }
    get sharedModel() {
        return this._sharedModel;
    }
    get contentChanged() {
        return this._contentChanged;
    }
    get stateChanged() {
        return this._stateChanged;
    }
    get dirty() {
        return this._dirty;
    }
    set dirty(value) {
        this._dirty = value;
    }
    get readOnly() {
        return this._readOnly;
    }
    set readOnly(value) {
        this._readOnly = value;
    }
    get disposed() {
        return this._disposed;
    }
    dispose() {
        if (this.isDisposed) {
            return;
        }
        super.dispose();
        this._sharedModel.dispose();
        this._disposed.emit();
        _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal.clearData(this);
    }
    toString() {
        return JSON.stringify({}, null, 2);
    }
    fromString(data) {
        /** */
    }
    toJSON() {
        return JSON.parse(this.toString());
    }
    fromJSON(data) {
        // nothing to do
    }
    sendMessage(message) {
        this._resetWritingStatus();
        if (this._timeoutWriting !== null) {
            window.clearTimeout(this._timeoutWriting);
        }
        const msg = {
            type: 'msg',
            id: _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.UUID.uuid4(),
            body: message.body,
            time: Date.now() / 1000,
            sender: this._user.username,
            raw_time: true
        };
        // Add the user if it does not exist or has changed
        if (!(this.sharedModel.getUser(this._user.username) === this._user)) {
            this.sharedModel.setUser(this._user);
        }
        this.sharedModel.addMessage(msg);
    }
    updateMessage(id, updatedMessage) {
        const index = this.sharedModel.getMessageIndex(id);
        let message = this.sharedModel.getMessage(index);
        if (message) {
            message.body = updatedMessage.body;
            message.edited = true;
        }
        else {
            const sender = updatedMessage.sender.username;
            message = {
                type: 'msg',
                id: id || _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.UUID.uuid4(),
                body: updatedMessage.body,
                time: updatedMessage.time || Date.now() / 1000,
                sender: sender,
                edited: true
            };
        }
        this.sharedModel.updateMessage(index, message);
    }
    deleteMessage(id) {
        const index = this.sharedModel.getMessageIndex(id);
        const message = this.sharedModel.getMessage(index);
        if (!message) {
            console.error('The message to delete does not exist');
            return;
        }
        message.body = '';
        message.deleted = true;
        this.sharedModel.updateMessage(index, message);
    }
    /**
     * Function called by the input on key pressed.
     */
    inputChanged(input) {
        if (!input || !this.config.sendTypingNotification) {
            return;
        }
        const awareness = this.sharedModel.awareness;
        if (this._timeoutWriting !== null) {
            window.clearTimeout(this._timeoutWriting);
        }
        awareness.setLocalStateField('isWriting', true);
        this._timeoutWriting = window.setTimeout(() => {
            this._resetWritingStatus();
        }, WRITING_DELAY);
    }
    _resetWritingStatus() {
        const awareness = this.sharedModel.awareness;
        const states = awareness.getLocalState();
        states === null || states === void 0 ? true : delete states.isWriting;
        awareness.setLocalState(states);
        this._timeoutWriting = null;
    }
}


/***/ }),

/***/ "../../packages/jupyterlab-collaborative-chat/lib/token.js":
/*!*****************************************************************!*\
  !*** ../../packages/jupyterlab-collaborative-chat/lib/token.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CommandIDs: () => (/* binding */ CommandIDs),
/* harmony export */   IActiveCellManagerToken: () => (/* binding */ IActiveCellManagerToken),
/* harmony export */   IChatFactory: () => (/* binding */ IChatFactory),
/* harmony export */   IChatPanel: () => (/* binding */ IChatPanel),
/* harmony export */   ISelectionWatcherToken: () => (/* binding */ ISelectionWatcherToken),
/* harmony export */   chatFileType: () => (/* binding */ chatFileType)
/* harmony export */ });
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter/chat */ "webpack/sharing/consume/default/@jupyter/chat/@jupyter/chat?4f0c");
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_chat__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */


/**
 * The file type for a chat document.
 */
const chatFileType = {
    name: 'chat',
    displayName: 'Chat',
    mimeTypes: ['text/json', 'application/json'],
    extensions: ['.chat'],
    fileFormat: 'text',
    contentType: 'chat',
    icon: _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__.chatIcon
};
/**
 * The token for the chat widget factory.
 */
const IChatFactory = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.Token('jupyter-collaborative-chat:IChatFactory');
/**
 * Command ids.
 */
const CommandIDs = {
    /**
     * Create a chat file.
     */
    createChat: 'collaborative-chat:create',
    /**
     * Open a chat file.
     */
    openChat: 'collaborative-chat:open',
    /**
     * Move a main widget to the side panel.
     */
    moveToSide: 'collaborative-chat:moveToSide',
    /**
     * Mark as read.
     */
    markAsRead: 'collaborative-chat:markAsRead',
    /**
     * Focus the input of the current chat.
     */
    focusInput: 'collaborative-chat:focusInput'
};
/**
 * The chat panel token.
 */
const IChatPanel = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.Token('jupyter-collaborative-chat:IChatPanel');
/**
 * The active cell manager plugin.
 */
const IActiveCellManagerToken = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.Token('jupyter-collaborative-chat:IActiveCellManager');
/**
 * The selection watcher plugin.
 */
const ISelectionWatcherToken = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.Token('jupyter-collaborative-chat:ISelectionWatcher');


/***/ }),

/***/ "../../packages/jupyterlab-collaborative-chat/lib/widget.js":
/*!******************************************************************!*\
  !*** ../../packages/jupyterlab-collaborative-chat/lib/widget.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChatPanel: () => (/* binding */ ChatPanel),
/* harmony export */   CollaborativeChatPanel: () => (/* binding */ CollaborativeChatPanel)
/* harmony export */ });
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter/chat */ "webpack/sharing/consume/default/@jupyter/chat/@jupyter/chat?4f0c");
/* harmony import */ var _jupyter_chat__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_chat__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/docregistry */ "webpack/sharing/consume/default/@jupyterlab/docregistry");
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _token__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./token */ "../../packages/jupyterlab-collaborative-chat/lib/token.js");
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */







const MAIN_PANEL_CLASS = 'jp-collab-chat-main-panel';
const TITLE_UNREAD_CLASS = 'jp-collab-chat-title-unread';
const SIDEPANEL_CLASS = 'jp-collab-chat-sidepanel';
const ADD_BUTTON_CLASS = 'jp-collab-chat-add';
const OPEN_SELECT_CLASS = 'jp-collab-chat-open';
const SECTION_CLASS = 'jp-collab-chat-section';
const TOOLBAR_CLASS = 'jp-collab-chat-toolbar';
/**
 * DocumentWidget: widget that represents the view or editor for a file type.
 */
class CollaborativeChatPanel extends _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__.DocumentWidget {
    constructor(options) {
        super(options);
        /**
         * Add class to tab when messages are unread.
         */
        this._unreadChanged = (_, unread) => {
            if (unread.length) {
                if (!this.title.className.includes(TITLE_UNREAD_CLASS)) {
                    this.title.className += ` ${TITLE_UNREAD_CLASS}`;
                }
            }
            else {
                this.title.className = this.title.className.replace(TITLE_UNREAD_CLASS, '');
            }
        };
        this.addClass(MAIN_PANEL_CLASS);
        this.model.name = this.context.localPath;
        this.model.unreadChanged.connect(this._unreadChanged);
    }
    /**
     * Dispose of the resources held by the widget.
     */
    dispose() {
        this.model.unreadChanged.disconnect(this._unreadChanged);
        this.context.dispose();
        this.content.dispose();
        super.dispose();
    }
    /**
     * The model for the widget.
     */
    get model() {
        return this.context.model;
    }
}
/**
 * Sidepanel widget including the chats and the add chat button.
 */
class ChatPanel extends _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.SidePanel {
    /**
     * The constructor of the chat panel.
     */
    constructor(options) {
        super(options);
        /**
         * Update the list of available chats in the root directory of the drive.
         */
        this.updateChatNames = async () => {
            const extension = _token__WEBPACK_IMPORTED_MODULE_6__.chatFileType.extensions[0];
            this._drive
                .get('.')
                .then(contentModel => {
                const chatsNames = {};
                contentModel.content
                    .filter(f => f.type === 'file' && f.name.endsWith(extension))
                    .forEach(f => (chatsNames[_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_1__.PathExt.basename(f.name, extension)] = f.name));
                this._chatNamesChanged.emit(chatsNames);
            })
                .catch(e => console.error('Error getting the chat files from drive', e));
        };
        /**
         * Handle `change` events for the HTMLSelect component.
         */
        this._chatSelected = (event) => {
            const select = event.target;
            const path = select.value;
            const name = select.options[select.selectedIndex].textContent;
            if (name === '-') {
                return;
            }
            this._commands.execute(_token__WEBPACK_IMPORTED_MODULE_6__.CommandIDs.openChat, {
                filepath: path,
                inSidePanel: true
            });
            event.target.selectedIndex = 0;
        };
        this._chatNamesChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_4__.Signal(this);
        this._config = {};
        this.addClass(SIDEPANEL_CLASS);
        this._commands = options.commands;
        this._drive = options.drive;
        this._rmRegistry = options.rmRegistry;
        this._themeManager = options.themeManager;
        this._autocompletionRegistry = options.autocompletionRegistry;
        const addChat = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.CommandToolbarButton({
            commands: this._commands,
            id: _token__WEBPACK_IMPORTED_MODULE_6__.CommandIDs.createChat,
            args: { inSidePanel: true },
            icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.addIcon
        });
        addChat.addClass(ADD_BUTTON_CLASS);
        this.toolbar.addItem('createChat', addChat);
        this._openChat = _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.ReactWidget.create(react__WEBPACK_IMPORTED_MODULE_5___default().createElement(ChatSelect, { chatNamesChanged: this._chatNamesChanged, handleChange: this._chatSelected.bind(this) }));
        this._openChat.addClass(OPEN_SELECT_CLASS);
        this.toolbar.addItem('openChat', this._openChat);
        const content = this.content;
        content.expansionToggled.connect(this._onExpansionToggled, this);
    }
    /**
     * Getter and setter of the config, propagated to all the chat widgets.
     */
    get config() {
        return this._config;
    }
    set config(value) {
        this._config = { ...this._config, ...value };
        this.widgets.forEach(w => {
            w.model.config = value;
        });
    }
    /**
     * Add a new widget to the chat panel.
     *
     * @param model - the model of the chat widget
     * @param name - the name of the chat.
     */
    addChat(model, name, path) {
        // Collapse all chats
        const content = this.content;
        for (let i = 0; i < this.widgets.length; i++) {
            content.collapse(i);
        }
        // Set the id of the model.
        model.name = name;
        // Create a new widget.
        const widget = new _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__.ChatWidget({
            model: model,
            rmRegistry: this._rmRegistry,
            themeManager: this._themeManager,
            autocompletionRegistry: this._autocompletionRegistry
        });
        this.addWidget(new ChatSection({ name, widget, commands: this._commands, path }));
    }
    /**
     * Open a chat if it exists in the side panel.
     *
     * @param path - the path of the chat.
     * @returns a boolean, whether the chat existed in the side panel or not.
     */
    openIfExists(path) {
        const index = this._getChatIndex(path);
        if (index > -1) {
            this._expandChat(index);
        }
        return index > -1;
    }
    /**
     * A message handler invoked on an `'after-show'` message.
     */
    onAfterShow(msg) {
        var _a;
        // Wait for the component to be rendered.
        (_a = this._openChat.renderPromise) === null || _a === void 0 ? void 0 : _a.then(() => this.updateChatNames());
    }
    /**
     * Return the index of the chat in the list (-1 if not opened).
     *
     * @param name - the chat name.
     */
    _getChatIndex(path) {
        return this.widgets.findIndex(w => w.path === path);
    }
    /**
     * Expand the chat from its index.
     */
    _expandChat(index) {
        if (!this.widgets[index].isVisible) {
            this.content.expand(index);
        }
    }
    /**
     * Triggered when a section is toogled. If the section is opened, all others
     * sections are closed.
     */
    _onExpansionToggled(panel, index) {
        if (!this.widgets[index].isVisible) {
            return;
        }
        for (let i = 0; i < this.widgets.length; i++) {
            if (i !== index) {
                panel.collapse(i);
            }
        }
    }
}
/**
 * The chat section containing a chat widget.
 */
class ChatSection extends _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.PanelWithToolbar {
    /**
     * Constructor of the chat section.
     */
    constructor(options) {
        var _a;
        super(options);
        /**
         * Change the title when messages are unread.
         *
         * TODO: fix it upstream in @jupyterlab/ui-components.
         * Updating the title create a new Title widget, but does not attach again the
         * toolbar. The toolbar is attached only when the title widget is attached the first
         * time.
         */
        this._unreadChanged = (_, unread) => {
            this._markAsRead.enabled = unread.length > 0;
            // this.title.label = `${unread.length ? '* ' : ''}${this._name}`;
        };
        this.addClass(SECTION_CLASS);
        this._name = options.name;
        this._path = options.path;
        this.title.label = this._name;
        this.title.caption = this._path;
        this.toolbar.addClass(TOOLBAR_CLASS);
        this._markAsRead = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.ToolbarButton({
            icon: _jupyter_chat__WEBPACK_IMPORTED_MODULE_0__.readIcon,
            iconLabel: 'Mark chat as read',
            className: 'jp-mod-styled',
            onClick: () => (this.model.unreadMessages = [])
        });
        const moveToMain = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.ToolbarButton({
            icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.launchIcon,
            iconLabel: 'Move the chat to the main area',
            className: 'jp-mod-styled',
            onClick: () => {
                this.model.dispose();
                options.commands.execute(_token__WEBPACK_IMPORTED_MODULE_6__.CommandIDs.openChat, {
                    filepath: `${this._name}${_token__WEBPACK_IMPORTED_MODULE_6__.chatFileType.extensions[0]}`
                });
                this.dispose();
            }
        });
        const closeButton = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.ToolbarButton({
            icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.closeIcon,
            iconLabel: 'Close the chat',
            className: 'jp-mod-styled',
            onClick: () => {
                this.model.dispose();
                this.dispose();
            }
        });
        this.toolbar.addItem('collaborativeChat-markRead', this._markAsRead);
        this.toolbar.addItem('collaborativeChat-moveMain', moveToMain);
        this.toolbar.addItem('collaborativeChat-close', closeButton);
        this.addWidget(options.widget);
        (_a = this.model.unreadChanged) === null || _a === void 0 ? void 0 : _a.connect(this._unreadChanged);
        this._markAsRead.enabled = this.model.unreadMessages.length > 0;
        options.widget.node.style.height = '100%';
    }
    /**
     * The path of the chat.
     */
    get path() {
        return this._path;
    }
    /**
     * The name of the chat.
     */
    get name() {
        return this._name;
    }
    /**
     * The model of the widget.
     */
    get model() {
        return this.widgets[0].model;
    }
    /**
     * Dispose of the resources held by the widget.
     */
    dispose() {
        var _a;
        (_a = this.model.unreadChanged) === null || _a === void 0 ? void 0 : _a.disconnect(this._unreadChanged);
        super.dispose();
    }
}
/**
 * A component to select a chat from the drive.
 */
function ChatSelect({ chatNamesChanged, handleChange }) {
    // An object associating a chat name to its path. Both are purely indicative, the name
    // is the section title and the path is used as caption.
    const [chatNames, setChatNames] = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)({});
    // Update the chat list.
    chatNamesChanged.connect((_, chatNames) => {
        setChatNames(chatNames);
    });
    return (react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_3__.HTMLSelect, { onChange: handleChange },
        react__WEBPACK_IMPORTED_MODULE_5___default().createElement("option", { value: "-" }, "Open a chat"),
        Object.keys(chatNames).map(name => (react__WEBPACK_IMPORTED_MODULE_5___default().createElement("option", { value: chatNames[name] }, name)))));
}


/***/ }),

/***/ "../../packages/jupyterlab-collaborative-chat/lib/ychat.js":
/*!*****************************************************************!*\
  !*** ../../packages/jupyterlab-collaborative-chat/lib/ychat.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   YChat: () => (/* binding */ YChat)
/* harmony export */ });
/* harmony import */ var _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter/ydoc */ "webpack/sharing/consume/default/@jupyter/ydoc");
/* harmony import */ var _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__);
/*
 * Copyright (c) Jupyter Development Team.
 * Distributed under the terms of the Modified BSD License.
 */


/**
 * The collaborative chat shared document.
 */
class YChat extends _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_0__.YDocument {
    /**
     * Create a new collaborative chat model.
     */
    constructor(options) {
        super(options);
        /**
         * Document version
         */
        this.version = '1.0.0';
        this._usersObserver = (event) => {
            const userChange = new Array();
            event.keysChanged.forEach(key => {
                const change = event.changes.keys.get(key);
                if (change) {
                    switch (change.action) {
                        case 'add':
                            userChange.push({
                                key,
                                newValue: this._users.get(key),
                                type: 'add'
                            });
                            break;
                        case 'delete':
                            userChange.push({
                                key,
                                oldValue: change.oldValue,
                                type: 'remove'
                            });
                            break;
                        case 'update':
                            userChange.push({
                                key: key,
                                oldValue: change.oldValue,
                                newValue: this._users.get(key),
                                type: 'change'
                            });
                            break;
                    }
                }
            });
            this._changed.emit({ userChange: userChange });
        };
        this._messagesObserver = (event) => {
            const messageChanges = event.delta;
            this._changed.emit({
                messageChanges: messageChanges
            });
        };
        this._metadataObserver = (event) => {
            const metadataChange = new Array();
            event.changes.keys.forEach((change, key) => {
                switch (change.action) {
                    case 'add':
                        metadataChange.push({
                            key,
                            newValue: this._metadata.get(key),
                            type: 'add'
                        });
                        break;
                    case 'delete':
                        metadataChange.push({
                            key,
                            oldValue: change.oldValue,
                            type: 'remove'
                        });
                        break;
                    case 'update':
                        metadataChange.push({
                            key: key,
                            oldValue: change.oldValue,
                            newValue: this._metadata.get(key),
                            type: 'change'
                        });
                        break;
                }
            });
            this._changed.emit({
                metadataChanges: metadataChange
            });
        };
        this._users = this.ydoc.getMap('users');
        this._users.observe(this._usersObserver);
        this._messages = this.ydoc.getArray('messages');
        this._messages.observe(this._messagesObserver);
        this._metadata = this.ydoc.getMap('metadata');
        this._metadata.observe(this._metadataObserver);
    }
    /**
     * Static method to create instances on the sharedModel
     *
     * @returns The sharedModel instance
     */
    static create(options) {
        return new YChat(options);
    }
    get id() {
        return this._metadata.get('id') || '';
    }
    get users() {
        return _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.JSONExt.deepCopy(this._users.toJSON());
    }
    get messages() {
        return _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.JSONExt.deepCopy(this._messages.toJSON());
    }
    getUser(username) {
        if (!username) {
            return undefined;
        }
        return this._users.get(username);
    }
    setUser(value) {
        this.transact(() => {
            this._users.set(value.username, value);
        });
    }
    getMessage(index) {
        return this._messages.get(index);
    }
    addMessage(value) {
        this.transact(() => {
            this._messages.push([value]);
        });
    }
    updateMessage(index, value) {
        this.transact(() => {
            this._messages.delete(index);
            this._messages.insert(index, [value]);
        });
    }
    getMessageIndex(id) {
        return this._messages.toArray().findIndex(msg => msg.id === id);
    }
    deleteMessage(index) {
        this.transact(() => {
            this._messages.delete(index);
        });
    }
}


/***/ })

}]);
//# sourceMappingURL=packages_jupyterlab-collaborative-chat_lib_index_js.1ebbd0a01df3449525df.js.map